// ---------------------------------------------------------------------------
//	PSG-like sound generator
//	Copyright (C) cisc 1997, 1999.
// ---------------------------------------------------------------------------
//	$Id: psg.h,v 1.6 2000/09/08 13:45:57 cisc Exp $

#ifndef PSG_H
#define PSG_H

#include "cisc.h"

#define PSG_SAMPLETYPE		int32		// int32 or int16
#define PSG_IPSCALE			16384
#define PSG_INTERPOLATE(y, x)	\
	(((((((-y[0]+3*y[1]-3*y[2]+y[3]) * x + PSG_IPSCALE/2) / PSG_IPSCALE \
	+ 3 * (y[0]-2*y[1]+y[2])) * x + PSG_IPSCALE/2) / PSG_IPSCALE \
	- 2*y[0]-3*y[1]+6*y[2]-y[3]) * x + 3*PSG_IPSCALE) / (6*PSG_IPSCALE) + y[1])

// ---------------------------------------------------------------------------
//	class PSG
//	PSG ɗǂ𐶐鉹jbg
//	
//	interface:
//	bool SetClock(uint clock, uint rate, bool ipflag)
//		D̃NXgpOɂȂ炸ĂłƁD
//		PSG ̃NbN PCM [gݒ肷
//		(IWifmgenɑ΂ipflagǉĂ̂ɒ)
//
//		clock:	PSG ̓NbN
//		rate:	 PCM ̃[g
//		ipflag:	`ON/OFF
//		retval	ɐ true
//
//	void Mix(Sample* dest, int nsamples)
//		PCM  nsamples C dest Ŏn܂zɉ(Z)
//		܂ŉZȂ̂ŁCŏɔz[NAKv
//	
//	void Reset()
//		Zbg
//
//	void SetReg(uint reg, uint8 data)
//		WX^ reg  data 
//	
//	uint GetReg(uint reg)
//		WX^ reg ̓eǂݏo
//	
//	void SetVolume(int db)
//		ẻʂ𒲐߂
//		Pʂ͖ 1/2 dB
//
class PSG
{
public:
	typedef PSG_SAMPLETYPE Sample;
	
	enum
	{
		noisetablesize = 1 << 11,	// gpʂ炵Ȃ猸炵
		toneshift = 24,
		envshift = 22,
		noiseshift = 14,
		oversampling = 2,		//  葬xDȂ猸炷Ƃ
	};

public:
	PSG();
	~PSG();

	void Mix(Sample* dest, int nsamples);
	void Mix2(Sample* dest, int nsamples, int vol_l, int vol_r);
	void SetClock(int clock, int rate, bool ipflag);

	void SetVolume(int vol);
	void SetChannelMask(int c);

	void Reset();
	void SetReg(uint regnum, uint8 data);
	uint GetReg(uint regnum) { return reg[regnum & 0x0f]; }

	int rcnt;
	int32 rbuf[3][512];

protected:
	void MakeNoiseTable();
	void MakeEnvelopTable();
	static void StoreSample(Sample& dest, int32 data);
	
	uint8 reg[16];

	const uint* envelop;
	uint olevel[3];
	uint32 scount[3], speriod[3];
	uint32 ecount, eperiod;
	uint32 ncount, nperiod;
	uint32 tperiodbase;
	uint32 eperiodbase;
	uint32 nperiodbase;
	int volume;
	int mask;

	static uint enveloptable[16][64];
	static uint noisetable[noisetablesize];
	static int EmitTable[32];
	static bool table_initialize;

	uint	psgrate;

	// ԃ[hp
	bool	interpolation;
	int32	mixdelta;
	int		mpratio;
	int32	mb[4];
};

#endif // PSG_H
