/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ TTLpbg(MB15021) ]
 *
 *	RHG
 *	  2002.01.28		MB15021̎dlɍ킹ăf[^SrbgA40EX̂
 *						ǂݏof[^̃}XNs悤ɕύX
 *						(2003.01.14 AVł4rbgǂݏΉmF)
 *	  2002.05.25		svȉʍĕ`ʒm}悤ɂ
 */

#include <string.h>
#include "xm7.h"
#include "ttlpalet.h"
#include "device.h"
#include "display.h"
#include "subctrl.h"

/*
 *	O[o [N
 */
BYTE ttl_palet[8];			/* TTLpbgf[^ */

/*
 *	TTLpbg
 *	
 */
BOOL FASTCALL ttlpalet_init(void)
{
	return TRUE;
}

/*
 *	TTLpbg
 *	N[Abv
 */
void FASTCALL ttlpalet_cleanup(void)
{
}

/*
 *	TTLpbg
 *	Zbg
 */
void FASTCALL ttlpalet_reset(void)
{
	int i;
	
	/* ׂĂ̐F */
	for (i=0; i<8; i++) {
		ttl_palet[i] = (BYTE)(i | 0x08);
	}

	/* ʒm */
	ttlpalet_notify();
}

/*
 *	TTLpbg
 *	PoCgǂݏo
 */
BOOL FASTCALL ttlpalet_readb(WORD addr, BYTE *dat)
{
#if XM7_VER == 1
	/* FM-8[hł͖ */
	if (fm_subtype == FMSUB_FM8) {
		return FALSE;
	}
#endif

	/* ͈̓`FbNAǂݏo */
	if ((addr >= 0xfd38) && (addr <= 0xfd3f)) {
		ASSERT((WORD)(addr - 0xfd38) <= 7);

		/* ʃju0xF0 */
#if XM7_VER >= 3
		if (fm7_ver == 3) {
			/* FM77AV40EXł͉3rbĝݗL */
			*dat = (BYTE)((ttl_palet[(WORD)(addr - 0xfd38)] & 0x07) | 0xf0);
		}
		else {
			/* FM-7/FM77AV(MB15021)ł͉4rbgL */
			*dat = (BYTE)(ttl_palet[(WORD)(addr - 0xfd38)] | 0xf0);
		}
#else
		/* FM-7/FM77AV(MB15021)ł͉4rbgL */
		*dat = (BYTE)(ttl_palet[(WORD)(addr - 0xfd38)] | 0xf0);
#endif

		return TRUE;
	}

	return FALSE;
}

/*
 *	TTLpbg
 *	PoCg
 */
BOOL FASTCALL ttlpalet_writeb(WORD addr, BYTE dat)
{
	int no;

#if XM7_VER == 1
	/* FM-8[hł͖ */
	if (fm_subtype == FMSUB_FM8) {
		return FALSE;
	}
#endif

	/* ͈̓`FbNA */
	if ((addr >= 0xfd38) && (addr <= 0xfd3f)) {
		no = addr - 0xfd38;
		if (ttl_palet[no] != (dat & 0x0f)) {
			ttl_palet[no] = (BYTE)(dat & 0x0f);
			refpalet_notify();

			/* ʒm */
#if XM7_VER >= 2
#if XM7_VER >= 3
			if (!(screen_mode & SCR_ANALOG)) {
#else
			if (!mode320) {
#endif
				ttlpalet_notify();
			}
#else
			ttlpalet_notify();
#endif
		}

		return TRUE;
	}

	return FALSE;
}

/*
 *	TTLpbg
 *	Z[u
 */
BOOL FASTCALL ttlpalet_save(int fileh)
{
	return file_write(fileh, ttl_palet, 8);
}

/*
 *	TTLpbg
 *	[h
 */
BOOL FASTCALL ttlpalet_load(int fileh, int ver)
{
	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	return file_read(fileh, ttl_palet, 8);
}
