/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ Win32API \ ]
 *
 *	RHG
 *	  2002.04.01		fBXvCoN̒ʒm}400C
 *						[ĥݗ}(Ӗsc)
 *	  2002.04.23		200C[hł}(@N)
 *	  2002.06.20		200C8F[h̗oNւ̏ݎ͒ʒm
 *						}悤ɂ(ƂȂ܂oOo肵)
 *						n[hEFAEBhEpʒm֐V
 *	  2002.09.15		V2߂o[Wƃ\[X𓝍
 *	  2004.03.17		^400CA_v^Ή
 *	  2008.01.20		ȂƂɂ
 *	  2012.05.01		tXN[ԕۑւ̑Ή
 *	  2012.07.01		O[j^[hɑΉ
 *	  2013.02.12		X^_OɑΉ
 */

#ifdef _WIN32

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <assert.h>
#include "xm7.h"
#include "device.h"
#include "subctrl.h"
#include "display.h"
#include "multipag.h"
#include "w32.h"
#include "w32_gdi.h"
#include "w32_dd.h"
#include "w32_draw.h"
#include "w32_sub.h"

/*
 *	O[o [N
 */
BOOL bFullScreen;							/* tXN[tO */
BOOL bFullRequested;						/* tXN[v */
BOOL bDrawSelected;							/* ZNgς݃tO */
BOOL bFullScan;								/* tXL(Window) */
BOOL bFullScanFS;							/* tXL(FullScreen) */
BOOL bDoubleSize;							/* 2{gtO */
#if XM7_VER == 1
BOOL bGreenMonitor;							/* O[j^tO */
#endif
#if XM7_VER == 2
BOOL bTTLMonitor;							/* TTLj^tO */
#endif
BOOL bRasterRendering;						/* X^_OtO */

/*
 *	X^eBbN [N
 */
static BOOL bNextFrameRender;				/* t[`tO */
static BOOL bDirtyLine[400];				/* vtO */

/*
 *	
 */
void FASTCALL InitDraw(void)
{
	/* [NGA */
	bFullScreen = FALSE;
	bFullRequested = FALSE;
	bDrawSelected = FALSE;
	bFullScan = FALSE;
	bFullScanFS = FALSE;
	bDoubleSize = FALSE;
#if XM7_VER == 1
	bGreenMonitor = FALSE;
#endif
#if XM7_VER == 2
	bTTLMonitor = FALSE;
#endif
	bRasterRendering = FALSE;
	bNextFrameRender = FALSE;
	memset(bDirtyLine, 0, sizeof(bDirtyLine));

	/* NGDIȂ̂ŁAGDI */
	InitGDI();
}

/*
 *	N[Abv
 */
void FASTCALL CleanDraw(void)
{
	/* tXN[tOɉāAN[Abv */
	if (bFullScreen) {
		CleanDD();
	}
	else {
		CleanGDI();
	}
}

/*
 *  ZNg
 */
BOOL FASTCALL SelectDraw(HWND hWnd)
{
	ASSERT(hWnd);

	/* ZNgς */
	bDrawSelected = TRUE;

	/* NGDII */
	return SelectGDI(hWnd);
}

/*
 *	[h؂ւ
 */
void FASTCALL ModeDraw(HWND hWnd, BOOL bFullFlag)
{
	ASSERT(hWnd);

	/* ƈvĂ΁AςKvȂ */
	if (bFullFlag == bFullScreen) {
		return;
	}

	if (bFullFlag) {
		/* tXN[ */
		CleanGDI();
		InitDD();
		bFullScreen = TRUE;
		if (!SelectDD()) {
			/* tXN[s */
			bFullScreen = FALSE;
			CleanDD();
			InitGDI();
			SelectGDI(hWnd);
		}
	}
	else {
		/* EChE */
		bFullScreen = FALSE;
		CleanDD();
		InitGDI();
		if (!SelectGDI(hWnd)) {
			/* EChEs */
			CleanGDI();
			bFullScreen = TRUE;
			InitDD();
			SelectDD();
		}
	}

	/* ĕ`̂ߏ׍H */
	display_notify();
}

/*
 *	`(ʏ)
 */
void FASTCALL OnDraw(HWND hWnd, HDC hDC)
{
	ASSERT(hWnd);
	ASSERT(hDC);

	/* G[Ȃ牽Ȃ */
	if (nErrorCode == 0) {
		if (bFullScreen) {
			if (bRasterRendering) {
				DrawPostRenderDD();
			}
			else {
				DrawDD();
			}
		}
		else {
			if (bRasterRendering) {
				DrawPostRenderGDI(hWnd, hDC);
			}
			else {
				DrawGDI(hWnd, hDC);
			}
		}
	}
}

/*
 *	`(WM_PAINT)
 */
void FASTCALL OnPaint(HWND hWnd)
{
	PAINTSTRUCT ps;
	HDC hDC;

	ASSERT(hWnd);

	hDC = BeginPaint(hWnd, &ps);

	/* G[Ȃ牽Ȃ */
	if (nErrorCode == 0) {
		/* ĕ`w */
		if (bFullScreen) {
			ReDrawDD();
		}
		else {
			ReDrawGDI();
		}

		/* ` */
		OnDraw(hWnd, hDC);
	}

	EndPaint(hWnd, &ps);
}

/*
 *	j[Jn
 */
void FASTCALL EnterMenu(HWND hWnd)
{
	if (bFullScreen) {
		EnterMenuDD(hWnd);
	}
	else {
		EnterMenuGDI(hWnd);
	}
}

/*
 *	j[I
 */
void FASTCALL ExitMenu(void)
{
	if (bFullScreen) {
		ExitMenuDD();
	}
	else {
		ExitMenuGDI();
	}
}

/*-[ VMƂ̐ڑ ]-----------------------------------------------------------*/

/*
 *	ĕ`惉X^ꊇݒ
 */
void FASTCALL SetDirtyFlag(int top, int bottom, BOOL flag)
{
	int y;

	if (bRasterRendering) {
		for (y = top; y < bottom; y++) {
			bDirtyLine[y] = flag;
		}
	}
}

/*
 *	VRAMݒʒm
 */
void FASTCALL vram_notify(WORD addr, BYTE dat)
{
	WORD y;

	UNUSED(dat);

#if XM7_VER >= 2
#if XM7_VER >= 3
	if (screen_mode == SCR_200LINE) {
#else
	if (!mode320) {
#endif
		if (vram_active != vram_display) {
			return;
		}
	}
#endif

	/* YWZo */
	if (bRasterRendering) {
#if XM7_VER >= 3
		switch (screen_mode) {
			case SCR_400LINE	:	addr &= 0x7fff;
									y = (WORD)(addr / 80);
									break;
			case SCR_262144		:
			case SCR_4096		:	addr &= 0x1fff;
									y = (WORD)(addr / 40);
									break;
			case SCR_200LINE	:	addr &= 0x3fff;
									y = (WORD)(addr / 80);
									break;
		}
#elif XM7_VER >= 2
		if (mode320) {
			addr &= 0x1fff;
			y = (WORD)(addr / 40);
		}
		else {
			addr &= 0x3fff;
			y = (WORD)(addr / 80);
		}
#elif defined(L4CARD)
		if (enable_400line) {
			addr -= vram_offset[0];
			addr &= 0x7fff;
			y = (WORD)(addr / 80);
		}
		else {
			addr &= 0x3fff;
			y = (WORD)(addr / 80);
		}
#else
		addr &= 0x3fff;
		y = (WORD)(addr / 80);
#endif
		if (y < 400) {
			bDirtyLine[y] = TRUE;
		}
	}

	if (bFullScreen) {
		VramDD(addr);
	}
	else {
		VramGDI(addr);
	}
}


/*
 *	TTLpbgʒm
 */
void FASTCALL ttlpalet_notify(void)
{
	if (bRasterRendering) {
		bNextFrameRender = TRUE;
		SetDirtyFlag(now_raster, 400, TRUE);
	}

	if (bFullScreen) {
		DigitalDD();
	}
	else {
		DigitalGDI();
	}
}

/*
 *	AiOpbgʒm
 */
void FASTCALL apalet_notify(void)
{
	if (bRasterRendering) {
		bNextFrameRender = TRUE;
		SetDirtyFlag(now_raster, 400, TRUE);
	}

	if (bFullScreen) {
		AnalogDD();
	}
	else {
		AnalogGDI();
	}
}

/*
 *  pbgύXʒm
 */
void FASTCALL refpalet_notify(void)
{
	bPaletteRefresh = TRUE;
}

/*
 *  ĕ`vʒm
 */
void FASTCALL display_notify(void)
{
	int i;
	int raster;

	if (bRasterRendering) {
		bNextFrameRender = TRUE;
		SetDirtyFlag(0, 400, TRUE);
		if (!run_flag) {
			raster = now_raster;
			for (i = 0; i < 400; i++) {
				now_raster = i;
				hblank_notify();
			}
			now_raster = raster;
		}
	}

	if (bFullScreen) {
		/* ReDraw͖ʂȃNA܂ނ̂ŁA׍H */
		AnalogDD();
	}
	else {
		AnalogGDI();
	}
}

/*
 *	VBLANKIvʒm
 */
void FASTCALL vblankperiod_notify(void)
{
	BOOL flag;
	int y;
	int ymax;

	if (bRasterRendering) {
		/* ̃t[Iɏ邩 */
		if (bNextFrameRender) {
			bNextFrameRender = FALSE;
			SetDirtyFlag(0, 400, TRUE);
		}
		else {
			/* Kv`FbN */
#if XM7_VER >= 3
			if (screen_mode == SCR_400LINE) {
				ymax = 400;
			}
			else {
				ymax = 200;
			}
#elif XM7_VER == 1 && defined(L4CARD)
			if (enable_400line) {
				ymax = 400;
			}
			else {
				ymax = 200;
			}
#else
			ymax = 200;
#endif
			flag = FALSE;
			for (y = 0; y < ymax; y++) {
				flag |= bDirtyLine[y];
			}
			if (!flag) {
				return;
			}
		}

		/* S̈_O */
		if (bFullScreen) {
			/* ReDraw͖ʂȃNA܂ނ̂ŁA׍H */
			AnalogDD();
		}
		else {
			AnalogGDI();
		}
	}
}

/*
 *	HBLANKvʒm
 */
void FASTCALL hblank_notify(void)
{
	if (bRasterRendering) {
		if (bDirtyLine[now_raster]) {
			bDirtyLine[now_raster] = FALSE;
			if (bFullScreen) {
				DrawRasterDD(now_raster);
			}
			else {
				DrawRasterGDI(now_raster);
			}
		}
	}
}

/*
 *	fBW^CYvʒm
 */
void FASTCALL digitize_notify(void)
{
}

#if XM7_VER >= 3
/*
 *	n[hEFAEBhEʒm
 */
void FASTCALL window_notify(void)
{
	if (bFullScreen) {
		WindowDD();
	}
	else {
		WindowGDI();
	}
}
#endif

#if XM7_VER == 1 && defined(L4CARD)
/*
 *	eLXgVRAMݒʒm
 */
void FASTCALL tvram_notify(WORD addr, BYTE dat)
{
	WORD ysize;
	WORD y;

	UNUSED(dat);

	if (bRasterRendering) {
		/* YWZo */
		addr = (WORD)((addr - text_start_addr) & 0x0ffe);
		ysize = (WORD)((crtc_register[9] & 0x1f) + 1);
		if (width40_flag) {
			y = (WORD)((addr / 80) * ysize);
		}
		else {
			y = (WORD)((addr / 160) * ysize);
		}

		/* I[o[`FbN */
		if (y >= 400) {
			return;
		}

		/* ĕ`tOݒ */
		SetDirtyFlag(y, y + ysize, TRUE);
	}

	if (bFullScreen) {
		TvramDD(addr);
	}
	else {
		TvramGDI(addr);
	}
}

/*
 *  eLXgĕ`vʒm
 */
void FASTCALL tvram_redraw_notify(void)
{
	bNextFrameRender = TRUE;
	SetDirtyFlag(now_raster, 400, TRUE);

	if (bFullScreen) {
		ReDrawTVRamDD();
	}
	else {
		ReDrawTVRamGDI();
	}
}
#endif

/*-[ V2 ]-------------------------------------------------------------------*/

#if ((XM7_VER <= 2) && defined(FMTV151))
/*
 *	V2
 *	0=߁A1=΁A2=
 */
const BYTE nV2data[] = {
/*						  1 1 1 1 1 1 1 1 1 1 2 2 2 2 2 2 2 2 */
/*		1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 */
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,1,1,1,1,1,1,1,2,0,0,
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,1,1,1,1,1,1,1,1,1,2,0,
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,1,1,1,1,2,0,0,1,1,1,1,2,
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,1,1,1,2,0,0,0,0,1,1,1,2,
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,0,0,0,1,1,1,1,2,0,
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,0,0,1,1,1,1,2,0,0,
		1,1,1,2,0,0,0,0,1,1,1,2,0,0,0,0,0,0,0,1,1,1,1,2,0,0,0,
		1,1,1,1,2,0,0,1,1,1,1,2,0,0,0,0,0,0,1,1,1,1,2,0,0,0,0,
		0,1,1,1,1,2,1,1,1,1,2,0,0,0,0,0,0,1,1,1,1,2,0,0,0,0,0,
		0,0,1,1,1,1,1,1,1,2,0,0,0,0,0,0,1,1,1,1,2,0,0,0,0,0,0,
		0,0,0,1,1,1,1,1,2,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,
		0,0,0,0,1,1,1,2,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,2,
};

#endif

#endif	/* _WIN32 */
