/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *							ROMEO support by usalin
 *
 *	[ Win32API TEh ]
 *
 *	RHG
 *	  2001.12.09		XeI[hǉ
 *	  2001.12.25		[`Q{(ohD)
 *						OPN/WHG/THGWX^֏݂sOɂ܂Ōo
 *						ԕ𐶐悤ɂ(ohD)
 *	  2001.12.26		TEhobt@ZƕsŗC
 *						[hɓ삵ȂC
 *	  2001.12.27		e[vj^̏ύX
 *						BEEPFMƓl̃^C~OŐ悤ɕύX
 *	  2002.01.23		TEhobt@ύX̏P(ohD)
 *	  2002.06.15		FM-7[h̓ƗPSGG~[VΉɔTHGg
 *						ptO̔ύX
 *	  2002.08.31		DirectSoundgpAvP[VƂ̓ɑΉ
 *	  2002.09.21		S98Oo͂ɑΉ
 *	  2002.11.11		FDDV[NECMT[o͗pWAVǉ
 *	  2002.11.25		TEhobt@TCY傫Ɖr؂
 *						C
 *	  2003.01.28		FDDV[N̍ő哯20ɕύX
 *	  2003.02.26		Oh!FMfڂ̃v^|[gڑ^CvD/ARo[^(W
 *						gh!?)ɑΉ
 *	  2003.05.15		VfmgengpOPN/WHG/THG̓ƗvXP[ݒɑΉ
 *	  2004.03.17		TEhobt@I[o[t[̏ύX
 *	  2004.08.13		OPN/WHG/THGopn.cւ̓ɍ킹ύXȂ
 *	  2007.12.16		p[g~[g@\ւ̏Jn
 *	  2010.01.23		ẽ{[E`lZp[Vݒ
 *						@\ǉ
 */

#ifdef _WIN32

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <mmsystem.h>
#define DIRECTSOUND_VERSION		0x300	/* DirectX3w */
#include <dsound.h>
#include <assert.h>
#include <math.h>
#include <objbase.h>
#include <tchar.h>
#include "xm7.h"
#include "device.h"
#include "mainetc.h"
#include "opn.h"
#include "tapelp.h"
#include "cisc.h"
#include "opna.h"
#include "psg.h"
#include "keyboard.h"
#include "w32.h"
#include "w32_sch.h"
#include "w32_snd.h"
#include "juliet.h"
#ifdef MIDI
#include "w32_midi.h"
#endif

/*
 *	O[o [N
 */
UINT nSampleRate;						/* TvO[g */
UINT nSoundBuffer;						/* TEhobt@TCY */
UINT uStereoOut;						/* o̓[h */
BOOL bInterpolation;					/* TEhԃ[h */
BOOL bForceStereo;						/* XeIo */
UINT nBeepFreq;							/* BEEPg */
BOOL bTapeMon;							/* e[vj^ */
int hWavCapture;						/* WAVLv`nh */
BOOL bWavCapture;						/* WAVLv`Jn */
UINT uClipCount;						/* NbsOJE^ */
#ifdef ROMEO
BOOL bUseRomeo;							/* ݂gptO */
#endif
DWORD dwSoundTotal;						/* TEhg[^ */
WORD nChannelMask[3];					/* `l}XN */
UINT uChSeparation;						/* `lZp[V */
int nFMVolume;							/* FM{[ */
int nPSGVolume;							/* PSG{[ */
int nBeepVolume;						/* BEEP{[ */
int nCMTVolume;							/* CMTj^{[ */
#ifdef FDDSND
int nWaveVolume;						/* eʉ{[ */
#endif

/*
 *	X^eBbN [N
 */
static LPDIRECTSOUND lpds;				/* DirectSound */
static LPDIRECTSOUNDBUFFER lpdsp;		/* DirectSoundBuffer(vC}) */
static LPDIRECTSOUNDBUFFER lpdsb;		/* DirectSoundBuffer(ZJ_) */
static DWORD *lpsbuf;					/* TEh쐬obt@ */
static BOOL bNowBank;					/* ݍĐ̃oN */
static UINT uBufSize;					/* TEhobt@TCY */
static UINT uRate;						/* [g */
static UINT uTick;						/* obt@TCY̒ */
static BOOL bMode;						/* TEhԃ[h */
static UINT uStereo;					/* o̓[h */
static UINT uSample;					/* TvJE^ */
static UINT uBeep;						/* BEEPg`JE^ */
static UINT uKeyEncBeep;				/* L[GR[_BEEPg`JE^ */
static FM::OPN *pOPN[3];				/* OPNfoCX */
static int nScale[3];					/* OPNvXP[ */
static BYTE uCh3Mode[3];				/* OPN Ch.3[h */
static BOOL bInitFlag;					/* tO */
static WORD *pWavCapture;				/* Lv`obt@(64KB) */
static UINT nWavCapture;				/* Lv`obt@f[^ */
static DWORD dwWavCapture;				/* Lv`t@CTCY */
static WORD uChannels;					/* o̓`l */
static BOOL bBeepFlag;					/* BEEPo */
static BOOL bKeyEncBeepFlag;			/* L[GR[_BEEPo */
static BOOL bTHGUse;					/* THGgptO(ۑp) */
static BOOL bPartMute[3][6];			/* p[g~[gtO */
static int nBeepLevel;					/* BEEPo̓x */
static int nCMTLevel;					/* CMTj^o̓x */
#ifdef FDDSND
static int nWaveLevel;					/* eʉo̓x */
#endif
static BOOL bTapeFlag;					/* ݂̃e[vo͏ */
static BOOL bTapeFlag2;					/* Õe[vo͏ */
static BYTE uTapeDelta;					/* e[vg`ԃJE^ */

#ifdef ROMEO
static BOOL bRomeoMute;					/* ݂~[gtO */
#endif

#ifdef FDDSND
/*
 *	X^eBbN [N (WAVĐ)
 */
static struct _WAVDATA {
	short *p;							/* g`f[^|C^ */
	DWORD size;							/* f[^TCY(Tv) */
	DWORD freq;							/* TvOg */
} Wav[3];

static struct _WAVPLAY {
	BOOL	bPlay;						/* WAVĐtO */
	DWORD	dwWaveNo;					/* WAVŁ[Ȃ΁[ */
	DWORD	dwCount1;					/* WAVŁ[() */
	DWORD	dwCount2;					/* WAVŁ[() */
	DWORD	dwCount3;					/* WAVĐ */
} WavP[SNDBUF];

static LPSTR WavName[] = {				/* WAVt@C */
	"RELAY_ON.WAV",
	"RELAYOFF.WAV",
	"FDDSEEK.WAV",
#if 0
	"HEADUP.WAV",
	"HEADDOWN.WAV",
#endif
};
#endif

/* XeIo͎̍EoXe[u */
static int l_vol[3][4] = {
	{	16,	23,	 9,	16	},
	{	16,	 9,	23,	 9	},
	{	16,	16,	16,	23	},
};
static int r_vol[3][4] = {
	{	16,	 9,	23,	16	},
	{	16,	23,	 9,	23	},
	{	16,	16,	16,	 9	},
};

/*
 *	vg^Cv錾
 */
#ifdef __cplusplus
extern "C" {
#endif
void (*CopySoundBuffer)(DWORD *src, WORD *dst, int count);
extern void CopySndBufMMX(DWORD *src, WORD *dst, int count);
extern void CopySndBuf(DWORD *src, WORD *dst, int count);
#ifdef __cplusplus
}
#endif

/*
 *	~[gp`l}XNrbg
 */
static const WORD nChannelMaskBit[6] = {
	0x000001, 0x000002, 0x000004, 0x000040, 0x000080, 0x000100
};

/*
 *	
 */
void FASTCALL InitSnd(void)
{
	int i;

	/* [NGA */
	nSampleRate = 44100;
	nSoundBuffer = 100;
	bInterpolation = FALSE;
	uChSeparation = 9;
	nFMVolume = 0;
	nPSGVolume = -2;
	nBeepVolume = -24;
	nCMTVolume = -24;
	nWaveVolume = 0;
	nBeepFreq = 1200;
	uStereoOut = 0;
	bForceStereo = FALSE;
	bTapeMon = TRUE;

	hWavCapture = -1;
	bWavCapture = FALSE;
	pWavCapture = NULL;
	nWavCapture = 0;
	dwWavCapture = 0;

	lpds = NULL;
	lpdsp = NULL;
	lpdsb = NULL;
	lpsbuf = NULL;
	bNowBank = FALSE;
	uBufSize = 0;
	uRate = 0;
	uSample = 0;
	uBeep = 0;
	bMode = FALSE;
	uStereo = 0;
	uChannels = 1;
	uClipCount = 0;

	bBeepFlag = FALSE;
	bKeyEncBeepFlag = FALSE;
	bTapeFlag = FALSE;
	bTapeFlag2 = FALSE;
	uTapeDelta = 0;

	for (i=0; i<3; i++) {
		pOPN[i] = NULL;
		nScale[i] = 0;
	}
	bTHGUse = FALSE;
	memset(uCh3Mode, 0xff, sizeof(uCh3Mode));
	memset(bPartMute, 0x00, sizeof(bPartMute));
	bInitFlag = FALSE;
#ifdef ROMEO
	bRomeoMute = FALSE;
#endif
	dwSoundTotal = 0;
	memset(nChannelMask, 0x00, sizeof(nChannelMask));

#ifdef MIDI
	/* MIDI[N */
	nMidiDelay = 100;
	bMidiDelayMode = TRUE;
#endif

	/* g`NbsO֐ݒ */
	if (bMMXflag) {
		CopySoundBuffer = CopySndBufMMX;
	}
	else {
		CopySoundBuffer = CopySndBuf;
	}
}

/*
 *	N[Abv
 */
void FASTCALL CleanSnd(void)
{
	int i;

	/* TEh~ */
	StopSnd();

	/* OPN */
	for (i=0; i<3; i++) {
		if (pOPN[i]) {
			delete pOPN[i];
			pOPN[i] = NULL;
		}
	}

	/* TEh쐬obt@ */
	if (lpsbuf) {
		free(lpsbuf);
		lpsbuf = NULL;
	}

	/* DirectSoundBuffer */
	if (lpdsb) {
		lpdsb->Release();
		lpdsb = NULL;
	}
	if (lpdsp) {
		lpdsp->Release();
		lpdsp = NULL;
	}

	/* DirectSound */
	if (lpds) {
		lpds->Release();
		lpds = NULL;
	}

	/* uRateNA */
	uRate = 0;

	/* Lv`֘A */
	if (hWavCapture >= 0) {
		CloseCaptureSnd();
	}
	if (pWavCapture) {
		free(pWavCapture);
		pWavCapture = NULL;
	}
	hWavCapture = -1;
	bWavCapture = FALSE;
}

#ifdef FDDSND
/*
 *	WAVEt@Cǂݍ (16rbgmf[^p)
 */
static BOOL FASTCALL LoadWav(LPSTR fname, struct _WAVDATA *wav)
{
	WAVEFORMATEX wfex;
	TCHAR path[_MAX_PATH];
	TCHAR drvname[_MAX_DRIVE];
	TCHAR dirname[_MAX_DIR];
	TCHAR filename[_MAX_FNAME];
	TCHAR extname[_MAX_EXT];
	BYTE buf[16];
	DWORD filSize;
	DWORD hdrSize;
	DWORD datSize;
	int fileh;

	ASSERT(fname);
	ASSERT(wav);

	/* t@CƊgqo */
	_tsplitpath(fname, NULL, NULL, filename, extname);

	/* XM7̃pX𓾂 */
	memset(path, 0, sizeof(path));
	GetModuleFileName(NULL, path, sizeof(path));
	_tsplitpath(path, drvname, dirname, NULL, NULL);

	/* pX */
	_tmakepath(path, drvname, dirname, filename, extname);

	/* t@CI[v */
	fileh = file_open(path, OPEN_R);
	if (fileh < 0) {
		return FALSE;
	}

	/* RIFFwb_`FbN */
	file_read(fileh, buf, 4);
	file_read(fileh, (BYTE *)&filSize, 4);
	buf[4] = '\0';
	if (strcmp((char *)buf, "RIFF")) {
		file_close(fileh);
		return FALSE;
	}
	filSize += 8;

	/* WAVEwb_`FbN */
	file_read(fileh, buf, 8);
	file_read(fileh, (BYTE *)&hdrSize, 4);
	buf[8] = '\0';
	if (strcmp((char *)buf, "WAVEfmt ")) {
		file_close(fileh);
		return FALSE;
	}
	hdrSize += (12 + 8);

	/* WAVEFORMATEX`FbN */
	file_read(fileh, (BYTE *)&wfex, sizeof(wfex));
	if ((wfex.wFormatTag != WAVE_FORMAT_PCM) ||
		(wfex.nChannels != 1) || (wfex.wBitsPerSample != 16)) {
		/* 16rbgmEjAPCMȊO͕s */
		file_close(fileh);
		return FALSE;
	}

	/* data`N */
	while (hdrSize < filSize) {
		/* `Nwb_ǂݍ */
		file_seek(fileh, hdrSize);
		file_read(fileh, buf, 4);
		file_read(fileh, (BYTE *)&datSize, 4);
		buf[4] = '\0';

		/* ̃`Nwb_ItZbgvZ */
		hdrSize += (datSize + 8);

		if (strcmp((char *)buf, "data") == 0) {
			/* data`Nǂݍ */
			wav->size = datSize / 2;
			wav->freq = wfex.nSamplesPerSec;
			wav->p = (short *)malloc(datSize);
			if (wav->p == NULL) {
				file_close(fileh);
				return FALSE;
			}
			if (!file_read(fileh, (BYTE *)wav->p, wav->size)) {
				file_close(fileh);
				free(wav->p);
				wav->p = NULL;
				return FALSE;
			}
			file_close(fileh);
			return TRUE;
		}
	}

	/* data`Nł */
	file_close(fileh);
	return FALSE;
}

/*
 *	FDDTEh 
 */
void FASTCALL InitFDDSnd(void)
{
	int i;

	/* [N */
	for (i=0; i<SNDBUF; i++) {
		memset(&WavP[i], 0, sizeof(_WAVPLAY));
	}

	/* WAVt@Cǂݍ */
	for (i=0; i<sizeof(Wav) / sizeof(_WAVDATA); i++) {
		if (!LoadWav(WavName[i], &Wav[i])) {
			Wav[i].size = 0;
			Wav[i].freq = 0;
		}
	}
}

/*
 *	FDDTEh N[Abv
 */
void FASTCALL CleanFDDSnd(void)
{
	int i;

	for (i=0; i<sizeof(Wav) / sizeof(_WAVDATA); i++) {
		if (Wav[i].p) {
			free(Wav[i].p);
			Wav[i].p = NULL;
		}
	}
}
#endif

/*
 *	WX^ݒ
 */
static void FASTCALL SetReg(FM::OPN *pOPN, BYTE *reg)
{
	int i;

	/* PSG */
	for (i=0; i<16; i++) {
		pOPN->SetReg((BYTE)i, reg[i]);
	}

	/* FML[It */
	for (i=0; i<3; i++) {
		pOPN->SetReg(0x28, (BYTE)i);
	}

	/* FMWX^ */
	for (i=0x30; i<0xb4; i++) {
		pOPN->SetReg((BYTE)i, reg[i]);
	}

	/* FM샂[h */
	pOPN->SetReg(0x27, reg[0x27] & 0xc0);
}

/*
 *	ZNg
 */
BOOL FASTCALL SelectSnd(HWND hWnd)
{
	PCMWAVEFORMAT pcmwf;
	DSBUFFERDESC dsbd;
	WAVEFORMATEX wfex;
	int i;

	/* assert */
	ASSERT(hWnd);

	/* NtOĂ */
	bInitFlag = TRUE;

	/* p[^ݒ */
	uRate = nSampleRate;
	uTick = nSoundBuffer;
	bMode = bInterpolation;
	uStereo = uStereoOut;
	uTapeDelta = 0;
	if ((uStereo > 0) || bForceStereo) {
		uChannels = 2;
	}
	else {
		uChannels = 1;
	}

	/* rate==0ȂAȂ */
	if (uRate == 0) {
		return TRUE;
	}

	/* DiectSoundIuWFNg쐬 */
	if (FAILED(DirectSoundCreate(NULL, &lpds, NULL))) {
		/* ftHgfoCXȂAgp */
		return TRUE;
	}

	/* xݒ(D拦) */
	if (FAILED(lpds->SetCooperativeLevel(hWnd, DSSCL_PRIORITY))) {
		return FALSE;
	}

	/* vC}obt@쐬 */
	memset(&dsbd, 0, sizeof(dsbd));
	dsbd.dwSize = sizeof(dsbd);
	dsbd.dwFlags = DSBCAPS_PRIMARYBUFFER;
	if (FAILED(lpds->CreateSoundBuffer(&dsbd, &lpdsp, NULL))) {
		return FALSE;
	}

	/* vC}obt@̃tH[}bgw */
	memset(&wfex, 0, sizeof(wfex));
	wfex.wFormatTag = WAVE_FORMAT_PCM;
	wfex.nChannels = uChannels;
	wfex.nSamplesPerSec = uRate;
	wfex.nBlockAlign = (WORD)(2 * uChannels);
	wfex.nAvgBytesPerSec = wfex.nSamplesPerSec * wfex.nBlockAlign;
	wfex.wBitsPerSample = 16;
	if (FAILED(lpdsp->SetFormat(&wfex))) {
		return FALSE;
	}

	/* ZJ_obt@쐬 */
	memset(&pcmwf, 0, sizeof(pcmwf));
	pcmwf.wf.wFormatTag = WAVE_FORMAT_PCM;
	pcmwf.wf.nChannels = uChannels;
	pcmwf.wf.nSamplesPerSec = uRate;
	pcmwf.wf.nBlockAlign = (WORD)(2 * uChannels);
	pcmwf.wf.nAvgBytesPerSec = pcmwf.wf.nSamplesPerSec * pcmwf.wf.nBlockAlign;
	pcmwf.wBitsPerSample = 16;
	memset(&dsbd, 0, sizeof(dsbd));
	dsbd.dwSize = sizeof(dsbd);
	dsbd.dwFlags = DSBCAPS_GLOBALFOCUS | DSBCAPS_GETCURRENTPOSITION2;
	dsbd.dwBufferBytes = (pcmwf.wf.nAvgBytesPerSec * uTick) / 1000;
	dsbd.dwBufferBytes += (DWORD)7;
	dsbd.dwBufferBytes &= (DWORD)0xfffffff8;	/* 8oCgE */
	uBufSize = dsbd.dwBufferBytes;
	dsbd.lpwfxFormat = (LPWAVEFORMATEX)&pcmwf;
	if (FAILED(lpds->CreateSoundBuffer(&dsbd, &lpdsb, NULL))) {
		return FALSE;
	}

	/* TEhobt@쐬(ZJ_obt@̔̎ԂŁADWORD) */
	lpsbuf = (DWORD *)malloc(uBufSize);
	if (lpsbuf == NULL) {
		return FALSE;
	}
	memset(lpsbuf, 0, uBufSize);

	/* TvJE^ATEhԂNA */
	uSample = 0;
	dwSoundTotal = 0;
	uClipCount = 0;

	/* OPNfoCX쐬 */
	for (i=0; i<3; i++) {
		pOPN[i] = new FM::OPN;
#if XM7_VER == 1
		if ((i == 1) && fmx_flag) {
			pOPN[i]->Init(PSG_CLOCK_MSX, uRate, bMode, NULL);
		}
		else {
			pOPN[i]->Init(OPN_CLOCK * 100, uRate, bMode, NULL);
		}
#else
		pOPN[i]->Init(OPN_CLOCK * 100, uRate, bMode, NULL);
#endif
		pOPN[i]->Reset();
		pOPN[i]->SetReg(0x27, 0);
	}

	/* ăZNgɔAWX^ݒ */
	for (i=0; i<3; i++) {
		nScale[i] = 0;
	}
	opn_notify(0x27, 0);
	whg_notify(0x27, 0);
	thg_notify(0x27, 0);
	for (i=0; i<3; i++) {
		SetReg(pOPN[i], opn_reg[i]);
	}

	/* Lv`֘A */
	if (!pWavCapture) {
		pWavCapture = (WORD *)malloc(sizeof(WORD) * 0x8000);
	}
	ASSERT(hWavCapture == -1);
	ASSERT(!bWavCapture);

	/* TEhX^[g */
	bNowBank = FALSE;
	PlaySnd();

	/* {[ݒ */
	SetSoundVolume();

	return TRUE;
}

/*
 *	Kp
 */
void FASTCALL ApplySnd(void)
{
	/* ŃA^[ */
	if (!bInitFlag) {
		return;
	}

	/* ROMEOgp̓~[g */
#ifdef ROMEO
	if (bRomeo) {
		ROMEO_Mute(!bUseRomeo);
	}
#endif

	/* p[^v`FbN */
	if ((uRate == nSampleRate) && (uTick == nSoundBuffer) &&
		(bMode == bInterpolation) && (uStereo == uStereoOut)) {
		return;
	}

	/* ɏłĂȂA */
	if (uRate != 0) {
		CleanSnd();
	}

	/* ăZNg */
	SelectSnd(hMainWnd);

	/* {[ݒ */
	SetSoundVolume();
}

/*
 *	{[ݒ
 */
void FASTCALL SetSoundVolume(void)
{
	int i;

	/* FM/PSG{[ݒ */
	for (i=0; i<3; i++) {
		ASSERT(pOPN[i]);

		if (pOPN[i]) {
			pOPN[i]->SetVolumeFM(nFMVolume * 2);
			pOPN[i]->psg.SetVolume(nPSGVolume * 2);
		}
	}

	/* BEEP/CMT/eʉ{[ݒ */
	nBeepLevel = (int)(32767.0 * pow(10.0, nBeepVolume / 20.0));
	nCMTLevel = (int)(32767.0 * pow(10.0, nCMTVolume / 20.0));
#ifdef FDDSND
	nWaveLevel = (int)(32767.0 * pow(10.0, nWaveVolume / 20.0));
#endif

	/* `lZp[Vݒ */
	l_vol[0][1] = l_vol[1][2] = l_vol[2][3] =
	r_vol[1][1] = r_vol[0][2] = r_vol[1][3] = 16 + uChSeparation;
	r_vol[0][1] = r_vol[1][2] = r_vol[2][3] =
	l_vol[1][1] = l_vol[0][2] = l_vol[1][3] = 16 - uChSeparation;
}

/*
 *	{[ݒ2(ݒ_CAOp)
 */
void FASTCALL SetSoundVolume2(UINT uSp, int nFM, int nPSG,
							  int nBeep, int nCMT, int nWav)
{
	int i;

	/* FM/PSG{[ݒ */
	for (i=0; i<3; i++) {
		ASSERT(pOPN[i]);

		if (pOPN[i]) {
			pOPN[i]->SetVolumeFM(nFM * 2);
			pOPN[i]->psg.SetVolume(nPSG * 2);
		}
	}

	/* BEEP/CMT/eʉ{[ݒ */
	nBeepLevel = (int)(32767.0 * pow(10.0, nBeep / 20.0));
	nCMTLevel = (int)(32767.0 * pow(10.0, nCMT / 20.0));
#ifdef FDDSND
	nWaveLevel = (int)(32767.0 * pow(10.0, nWav / 20.0));
#endif

	/* `lZp[Vݒ */
	l_vol[0][1] = l_vol[1][2] = l_vol[2][3] =
	r_vol[1][1] = r_vol[0][2] = r_vol[1][3] = 16 + uSp;
	r_vol[0][1] = r_vol[1][2] = r_vol[2][3] =
	l_vol[1][1] = l_vol[0][2] = l_vol[1][3] = 16 - uSp;
}

/*
 *	tJn
 */
void FASTCALL PlaySnd()
{
	HRESULT hr;
	WORD *ptr1, *ptr2;
	DWORD size1, size2;

	if (lpdsb) {
		/* obt@ׂăNA */
		if (lpsbuf) {
			memset(lpsbuf, 0, uBufSize);
		}

		/* bN */
		hr = lpdsb->Lock(0, uBufSize, (void **)&ptr1, &size1,
						(void**)&ptr2, &size2, 0);
		/* obt@Ă΁AXgA */
		if (hr == DSERR_BUFFERLOST) {
			lpdsb->Restore();
		}
		/* bNꍇ̂݁AZbg */
		if (SUCCEEDED(hr)) {
			if (ptr1) {
				memset(ptr1, 0, size1);
			}
			if (ptr2) {
				memset(ptr2, 0, size2);
			}

			/* AbN */
			lpdsb->Unlock(ptr1, size1, ptr2, size2);
		}

		/* tJn */
		lpdsb->Play(0, 0, DSBPLAY_LOOPING);
	}

	/* TvJE^ATEhԂNA */
	uSample = 0;
	dwSoundTotal = 0;
	uClipCount = 0;
}

/*
 *	t~
 */
void FASTCALL StopSnd()
{
	if (lpdsb) {
		lpdsb->Stop();
	}
}

/*
 *	BEEP
 */
static void FASTCALL BeepSnd(int32 *buf, int samples)
{
	int sf;
	int i;

	/* BEEPo̓`FbN */
	if (!bBeepFlag) {
		return;
	}

	/* Tv */
	for (i=0; i<samples; i++) {
		/* `g쐬 */
		sf = (int)(uBeep * nBeepFreq * 2);
		sf /= (int)uRate;

		/* EɉăTv */
		if (uChannels == 1) {
			if (sf & 1) {
				*buf++ += nBeepLevel;
			}
			else {
				*buf++ -= nBeepLevel;
			}
		}
		else {
			if (sf & 1) {
				*buf++ += nBeepLevel;
				*buf++ += nBeepLevel;
			}
			else {
				*buf++ -= nBeepLevel;
				*buf++ -= nBeepLevel;
			}
		}

		/* JE^Abv */
		uBeep++;
		if (uBeep >= uRate) {
			uBeep = 0;
		}
	}
}

/*
 *	BEEP
 */
static void FASTCALL KeyEncBeepSnd(int32 *buf, int samples)
{
	int sf;
	int i;

	/* BEEPo̓`FbN */
	if (!bKeyEncBeepFlag) {
		return;
	}

	/* Tv */
	for (i=0; i<samples; i++) {
		/* `g쐬 */
		sf = (int)(uKeyEncBeep * 2350 * 2);
		sf /= (int)uRate;

		/* EɉăTv */
		if (uChannels == 1) {
			if (sf & 1) {
				*buf++ += nBeepLevel;
			}
			else {
				*buf++ -= nBeepLevel;
			}
		}
		else {
			if (sf & 1) {
				*buf++ += nBeepLevel;
				*buf++ += nBeepLevel;
			}
			else {
				*buf++ -= nBeepLevel;
				*buf++ -= nBeepLevel;
			}
		}

		/* JE^Abv */
		uKeyEncBeep++;
		if (uKeyEncBeep >= uRate) {
			uKeyEncBeep = 0;
		}
	}
}

/*
 *	e[v
 */
static void FASTCALL TapeSnd(int32 *buf, int samples)
{
	DWORD dat;
	int i;
	int tmp;

	/* e[vo̓`FbN */
	if (!tape_motor || !bTapeMon) {
		return;
	}

	/* g`߂ */
	if ((uRate % 11025) == 0) {
		tmp = (uRate * 5) / 44100;
	}
	else {
		tmp = (uRate * 5) / 48000;
	}

	/* o͏ԂωꍇAg`ԂJn */
	if (bTapeFlag != bTapeFlag2) {
		if (!uTapeDelta) {
			uTapeDelta = 1;
		}
		else {
			uTapeDelta = (BYTE)(tmp - uTapeDelta + 1);
		}
	}

	/* Tv */
	for (i=0; i<samples; i++) {
		if (uTapeDelta) {
			/* g`Ԃ */
			dat = (0x1000 / tmp) * uTapeDelta;
			if (bTapeFlag) {
				dat = dat - nCMTLevel;
			}
			else {
				dat = nCMTLevel - dat;
			}

			uTapeDelta ++;
			if (uTapeDelta > tmp) {
				uTapeDelta = 0;
			}
		}
		else {
			/* g`ԂȂ */
			if (bTapeFlag) {
				dat = nCMTLevel;
			}
			else {
				dat = -nCMTLevel;
			}
		}

		*buf++ += dat;
		if (uChannels == 2) {
			*buf++ += dat;
		}
	}

	/* ݂̃e[vo͏Ԃۑ */
	bTapeFlag2 = bTapeFlag;
}

/*
 *	WAVf[^ (FDD/CMT)
 */
#ifdef FDDSND
static void FASTCALL WaveSnd(int32 *buf, int samples)
{
	int i;
	int j;
	int dat;

	/* Tv */
	for (i=0; i<samples; i++) {
		for (j=0; j<SNDBUF; j++) {
			if (WavP[j].bPlay) {
				dat = Wav[WavP[j].dwWaveNo].p[WavP[j].dwCount1];
				dat = (short)(((int)dat * nWaveLevel) >> 16);
				*buf += (int)dat;
				if (uChannels == 2) {
					*(buf+1) += (int)dat;
				}

				/* JEgAbv */
				WavP[j].dwCount2 += (Wav[WavP[j].dwWaveNo].freq << 16) / uRate;
				if (WavP[j].dwCount2 > 0x10000) {
					WavP[j].dwCount1 += (WavP[j].dwCount2 >> 16);
					WavP[j].dwCount2 &= 0xFFFF;
					if (WavP[j].dwCount1 >= Wav[WavP[j].dwWaveNo].size) {
						WavP[j].bPlay = FALSE;
					}
				}
				WavP[j].dwCount3 ++;
			}
		}
		buf ++;
		if (uChannels == 2) {
			buf ++;
		}
	}
}
#endif

/*
 *	g`
 */
static void FASTCALL MixingSound(DWORD *q, int samples, BOOL bZero)
{
	memset(q, 0, sizeof(DWORD) * samples * uChannels);
	if (!bZero) {
		if (uChannels == 1) {
			/* m */
			if (opn_use) {
#ifdef ROMEO
				if ((pOPN[OPN_STD]) && !bUseRomeo) {
#else
				if (pOPN[OPN_STD]) {
#endif
					pOPN[OPN_STD]->Mix((int32*)q, samples);
				}
			}
#if XM7_VER == 1
			if (fmx_flag || whg_use) {
#ifdef ROMEO
				if (bUseRomeo || fmx_flag) {
					pOPN[OPN_WHG]->psg.Mix((int32*)q, samples);
				}
				else {
					pOPN[OPN_WHG]->Mix((int32*)q, samples);
				}
#else
				pOPN[OPN_WHG]->Mix((int32*)q, samples);
#endif
			}
#else
			if (whg_use) {
#ifdef ROMEO
				if (bUseRomeo) {
					pOPN[OPN_WHG]->psg.Mix((int32*)q, samples);
				}
				else {
					pOPN[OPN_WHG]->Mix((int32*)q, samples);
				}
#else
				pOPN[OPN_WHG]->Mix((int32*)q, samples);
#endif
			}
#endif
			if (thg_use) {
				pOPN[OPN_THG]->Mix((int32*)q, samples);
			}
			else if (fm7_ver == 1) {
				pOPN[OPN_THG]->psg.Mix((int32*)q, samples);
			}
		}
		else {
			/* XeI */
			if (!whg_use && !thg_use) {
				/* WHG/THGgpĂȂ(m) */
				if (opn_use) {
#ifdef ROMEO
					if (!bUseRomeo) {
						pOPN[OPN_STD]->Mix2((int32*)q, samples, 16, 16);
					}
#else
					pOPN[OPN_STD]->Mix2((int32*)q, samples, 16, 16);
#endif
				}
#if XM7_VER == 1
				if (fmx_flag) {
					pOPN[OPN_WHG]->psg.Mix2((int32*)q, samples, 16, 16);
				}
#endif
				if (fm7_ver == 1) {
					pOPN[OPN_THG]->psg.Mix2((int32*)q, samples, 16, 16);
				}
			}
			else {
				/* WHG܂THGgp */
				if (opn_use) {
#ifdef ROMEO
					if (!bUseRomeo) {
						pOPN[OPN_STD]->Mix2((int32*)q, samples,
							l_vol[OPN_STD][uStereo], r_vol[OPN_STD][uStereo]);
					}
#else
					pOPN[OPN_STD]->Mix2((int32*)q, samples,
						l_vol[OPN_STD][uStereo], r_vol[OPN_STD][uStereo]);
#endif
				}
				if (whg_use) {
#ifdef ROMEO
					if (bUseRomeo) {
						pOPN[OPN_WHG]->psg.Mix2((int32*)q, samples,
							l_vol[OPN_WHG][uStereo], r_vol[OPN_WHG][uStereo]);
					}
					else {
						pOPN[OPN_WHG]->Mix2((int32*)q, samples,
							l_vol[OPN_WHG][uStereo], r_vol[OPN_WHG][uStereo]);
					}
#else
					pOPN[OPN_WHG]->Mix2((int32*)q, samples,
						l_vol[OPN_WHG][uStereo], r_vol[OPN_WHG][uStereo]);
#endif
				}
				if (thg_use) {
					pOPN[OPN_THG]->Mix2((int32*)q, samples,
						l_vol[OPN_THG][uStereo], r_vol[OPN_THG][uStereo]);
				}
				else if (fm7_ver == 1) {
					pOPN[OPN_THG]->psg.Mix2((int32*)q, samples, 16, 16);
				}
			}
		}

		/* e[v */
		TapeSnd((int32*)q, samples);

		/* r[v */
		BeepSnd((int32*)q, samples);
		KeyEncBeepSnd((int32*)q, samples);

#ifdef FDDSND
		/* WAVTEh */
		WaveSnd((int32*)q, samples);
#endif
	}
}

/*
 *	TEh쐬obt@֒ǉ
 */
static void FASTCALL AddSnd(BOOL bFill, BOOL bZero)
{
	int i;
	int samples;

	/* OPNfoCX쐬ĂȂ΁AȂ */
	if (!pOPN[OPN_STD] || !pOPN[OPN_WHG] || !pOPN[OPN_THG]) {
		return;
	}

	/* bFill̏ꍇ̃Tv */
	/* (m2byte/sampleEXeI4byte/sample) */
	samples = (uBufSize / uChannels) >> 2;
	samples -= uSample;

	/* !bFillȂAԂv */
	if (!bFill) {
		/* Ԍo߂狁߂_Tv */
		/* vZʂI[o[t[ɑ΍ 2002/11/25 */
		i = (uRate / 25);
		i *= dwSoundTotal;
		i /= 40000;

		/* uSampleƔrAvĂΉȂ */
		if (i <= (int)uSample) {
			return;
		}

		/* uSampleƂ̍񐶐Tv */
		i -= (int)(uSample);

		/* samples΍i */
		if (i <= samples) {
			samples = i;
		}
	}

	/* ~LVO */
	MixingSound(&lpsbuf[uSample * uChannels], samples, bZero);

	/* XV */
	if (bFill) {
		dwSoundTotal = 0;
		uSample = 0;
	}
	else {
		uSample += samples;
	}
}

/*
 *	WAVLv`
 */
static void FASTCALL WavCapture(void)
{
	UINT nSize;
	DWORD *p;
	WORD *q;
	int j;

	/* WAVLv`łȂ΁A^[ */
	if (hWavCapture < 0) {
		return;
	}
	ASSERT(pWavCapture);

	/* |C^ATCY(nSizeWORDϊBYTEl) */
	p = lpsbuf;
	nSize = uBufSize / 2;

	/* bWavCaptureFALSEȂ */
	if (!bWavCapture) {
		/* o`FbN */
		while (nSize > 0) {
			if (uChannels == 1) {
				if (*p != 0) {
					break;
				}
				else {
					nSize -= 2;
					p++;
				}
			}
			else {
				if ((p[0] != 0) || (p[1] != 0)) {
					break;
				}
				else {
					nSize -= 4;
					p += 2;
				}
			}
		}
		/*  */
		if (nSize == 0) {
			return;
		}
	}

	/* nWavCapturel */
	if ((nWavCapture + nSize) >= 0x8000) {
		/* 32KBς܂ŃRs[ */
		j = (0x8000 - nWavCapture) >> 1;
		q = &pWavCapture[nWavCapture >> 1];
		CopySoundBuffer(p, q, j);
		p += j;

		/* cTCYXV */
		nSize -= (0x8000 - nWavCapture);

		/*  */
		file_write(hWavCapture, (BYTE*)pWavCapture, 0x8000);
		dwWavCapture += 0x8000;
		nWavCapture = 0;
	}

	/* ]Rs[ */
	j = nSize >> 1;
	q = &pWavCapture[nWavCapture >> 1];
	CopySoundBuffer(p, q, j);
	nWavCapture += nSize;

	/* Ș^ */
	bWavCapture = TRUE;
}

/*
 *	
 */
BOOL FASTCALL ProcessSnd(BOOL bZero)
{
	DWORD dwPlayC, dwWriteC;
	BOOL bWrite;
	DWORD dwOffset;
	WORD *ptr1, *ptr2;
	DWORD size1, size2;
	DWORD *p;
	int i;
	int j;
	HRESULT hr;

	/* ݂R}hs by  */
#ifdef ROMEO
	if (bUseRomeo) {
		juliet_YMF288EXEC((DWORD)uTick);
	}
#endif

	/* MIDIR}hs */
#ifdef MIDI
	if (bMidiDelayMode) {
		MidiSendData((DWORD)uTick);
	}
	else {
		MidiSendData((DWORD)nMidiDelay);
	}
#endif

	/* ĂȂ΁AȂ */
	if (!lpdsb) {
		return TRUE;
	}

	/* ݈ʒu𓾂 */
	if (FAILED(lpdsb->GetCurrentPosition(&dwPlayC, &dwWriteC))) {
		return FALSE;
	}

	/* ݈ʒuƃoNAKv𔻒f */
	bWrite = FALSE;
	if (bNowBank) {
		if (dwPlayC >= (uBufSize / 2)) {
			dwOffset = 0;
			bWrite = TRUE;
		}
	}
	else {
		if (dwPlayC < (uBufSize / 2)) {
			dwOffset = uBufSize / 2;
			bWrite = TRUE;
		}
	}

	/* ޕKvȂ΁A^[ */
	if (!bWrite) {
		/* e[v */
		if (tape_motor && bTapeMon) {
			bWrite = TRUE;
		}
		/* BEEP */
		if (beep_flag && speaker_flag) {
			bWrite = TRUE;
		}

		/* ǂ炩ONȂAobt@[U */
		if (bWrite) {
			AddSnd(FALSE, bZero);
		}

		return FALSE;
	}

	/* ݁B܂TEh쐬obt@S߂ */
	AddSnd(TRUE, bZero);

	/* ŃbN */
	hr = lpdsb->Lock(dwOffset, uBufSize / 2, (void **)&ptr1, &size1,
						(void**)&ptr2, &size2, 0);

	/* obt@Ă΁AXgA */
	if (hr == DSERR_BUFFERLOST) {
		lpdsb->Restore();
		hr = lpdsb->Lock(dwOffset, uBufSize / 2, (void **)&ptr1, &size1,
							(void**)&ptr2, &size2, 0);
	}
	/* bNȂ΁AĂӖȂ */
	if (FAILED(hr)) {
		return FALSE;
	}

	/* TEh쐬obt@ZJ_obt@ */
	p = lpsbuf;
	i = (int)(size1 / 2);
	j = (int)(size2 / 2);
	CopySoundBuffer(p, ptr1, i);
	CopySoundBuffer(p + i, ptr2, j);

	/* AbN */
	lpdsb->Unlock(ptr1, size1, ptr2, size2);

	/* oN] */
	bNowBank = (!bNowBank);

	/* WAVLv` */
	WavCapture();

	return TRUE;
}

/*
 *	TEho͊ҋ@
 */
void FASTCALL WaitSnd(void)
{
	DWORD dwPlayC, dwWriteC;
	DWORD dwLength;

	while (TRUE) {
		/* ĂȂ΁AȂ */
		if (!lpdsb) {
			return;
		}

		/* ݈ʒu𓾂 */
		if (FAILED(lpdsb->GetCurrentPosition(&dwPlayC, &dwWriteC))) {
			break;
		}

		/* ݈ʒuƃoNAKv𔻒f */
		if (bNowBank) {
			if (dwPlayC >= (uBufSize / 2)) {
				break;
			}
			dwLength = (uBufSize / 2);
		}
		else {
			if (dwPlayC < (uBufSize / 2)) {
				break;
			}
			dwLength = uBufSize;
		}

		if ((dwLength - dwPlayC) * 1000 > uRate) {
			Sleep(1);
		}
	}
}

/*
 *	x擾
 */
int FASTCALL GetLevelSnd(int ch)
{
	FM::OPN *p;
	int i;
	double s;
	double t;
	int *buf;

	ASSERT((ch >= 0) && (ch < 18));

	/* OPN */
	if (ch < 6) {
		p = pOPN[OPN_STD];
#ifdef ROMEO
		/* ݂gp͎擾łȂ̂0 */
		if (bUseRomeo) {
			return 0;
		}
#endif

		/* ۂɎgĂȂ0 */
		if ((!opn_enable || !opn_use) && (fm7_ver == 1)) {
			return 0;
		}
	}

	/* WHG */
	if ((ch >= 6) && (ch < 12)) {
		p = pOPN[OPN_WHG];
		ch -= 6;

		/* ۂɎgĂȂ0 */
		if (!whg_enable || !whg_use) {
			return 0;
		}

#ifdef ROMEO
		/* ݂gpFM͎擾łȂ̂0 */
		if (bUseRomeo && (ch < 3)) {
			return 0;
		}
#endif
	}

	/* THG */
	if ((ch >= 12) && (ch < 18)) {
		p = pOPN[OPN_THG];
		ch -= 12;

		/* ۂɎgĂȂ0 */
		if ((!thg_enable || !thg_use) && (fm7_ver != 1)) {
			return 0;
		}
	}

	/* ݃`FbN */
	if (!p) {
		return 0;
	}

	/* FM,PSG̋ */
	if (ch < 3) {
		/* FM:512Tv2avZ */
		buf = p->rbuf[ch];

		s = 0;
		for (i=0; i<512; i++) {
			t = (double)*buf++;
			t *= t;
			s += t;
		}
		s /= 512;

		/* [`FbN */
		if (s == 0) {
			return 0;
		}

		/* log10 */
		s = log10(s);

		/* FM␳ */
		s *= 40.0;
	}
	else {
		/* PSG:512Tv2avZ */
		buf = p->psg.rbuf[ch - 3];

		s = 0;
		for (i=0; i<512; i++) {
			t = (double)*buf++;
			t *= t;
			s += t;
		}
		s /= 512;

		/* [`FbN */
		if (s == 0) {
			return 0;
		}

		/* log10 */
		s = log10(s);

		/* PSG␳ */
		s *= 60.0;
	}

	return (int)s;
}

/*
 *	WAVLv`Jn
 */
void FASTCALL OpenCaptureSnd(char *fname)
{
	WAVEFORMATEX wfex;
	DWORD dwSize;
	int fileh;

	ASSERT(fname);
	ASSERT(hWavCapture < 0);
	ASSERT(!bWavCapture);

	/* łȂ΁A^[ */
	if (!pOPN[OPN_STD] || !pOPN[OPN_WHG] || !pOPN[OPN_THG]) {
		return;
	}

	/* obt@΁A^[ */
	if (!pWavCapture) {
		return;
	}

	/* uBufSize / 20x8000ȉłȂƃG[ */
	if ((uBufSize / 2) > 0x8000) {
		return;
	}

	/* t@CI[v(݃[h) */
	fileh = file_open(fname, OPEN_W);
	if (fileh < 0) {
		return;
	}

	/* RIFFwb_ */
	if (!file_write(fileh, (BYTE*)"RIFFŎEWAVEfmt ", 16)) {
		file_close(fileh);
		return;
	}

	/* WAVEFORMATEX */
	dwSize = sizeof(wfex);
	if (!file_write(fileh, (BYTE*)&dwSize, sizeof(dwSize))) {
		file_close(fileh);
		return;
	}
	memset(&wfex, 0, sizeof(wfex));
	wfex.cbSize = sizeof(wfex);
	wfex.wFormatTag = WAVE_FORMAT_PCM;
	wfex.nChannels = uChannels;
	wfex.nSamplesPerSec = uRate;
	wfex.nBlockAlign = (WORD)(2 * uChannels);
	wfex.nAvgBytesPerSec = wfex.nSamplesPerSec * wfex.nBlockAlign;
	wfex.wBitsPerSample = 16;
	if (!file_write(fileh, (BYTE *)&wfex, sizeof(wfex))) {
		file_close(fileh);
		return;
	}

	/* dataTuwb_ */
	if (!file_write(fileh, (BYTE *)"dataŎE", 8)) {
		file_close(fileh);
		return;
	}

	/* ok */
	nWavCapture = 0;
	dwWavCapture = 0;
	bWavCapture = FALSE;
	hWavCapture = fileh;
}

/*
 *	WAVLv`I
 */
void FASTCALL CloseCaptureSnd(void)
{
	DWORD dwLength;

	ASSERT(hWavCapture >= 0);

	/* obt@Ɏc */
	file_write(hWavCapture, (BYTE*)pWavCapture, nWavCapture);
	dwWavCapture += nWavCapture;
	nWavCapture = 0;

	/* t@COX */
	file_seek(hWavCapture, 4);
	dwLength = dwWavCapture + sizeof(WAVEFORMATEX) + 20;
	file_write(hWavCapture, (BYTE *)&dwLength, sizeof(dwLength));

	/* dataOX */
	file_seek(hWavCapture, sizeof(WAVEFORMATEX) + 24);
	file_write(hWavCapture, (BYTE *)&dwWavCapture, sizeof(dwWavCapture));

	/* t@CN[Y */
	file_close(hWavCapture);

	/* [NGANA */
	hWavCapture = -1;
	bWavCapture = FALSE;
}

/*
 *	ROMEO ~[g
 */
#ifdef ROMEO
extern "C" {
void FASTCALL ROMEO_Mute(BOOL flag)
{
	int i;

	/* Ԃωꍇ̂ݏs */
	if (bRomeo && (bRomeoMute != flag)) {
		if (flag) {
			/* ~[g */
			juliet_YMF288Mute(FALSE);

			/* PSG */
			for (i=0; i<16; i++) {
				juliet_YMF288A_B((BYTE)i, opn_reg[OPN_STD][i]);
			}

			/* FML[It */
			for (i=0; i<3; i++) {
				juliet_YMF288A_B(0x28, (BYTE)i);
				juliet_YMF288A_B(0x28, (BYTE)(i | 0x04));
			}

			/* FMWX^ */
			for (i=0x30; i<0xb4; i++) {
				juliet_YMF288A_B((BYTE)i, opn_reg[OPN_STD][i]);
				juliet_YMF288B_B((BYTE)i, opn_reg[OPN_WHG][i]);
			}

			/* FM샂[h */
			juliet_YMF288A_B((BYTE)0x27, (BYTE)(opn_reg[OPN_STD][0x27] & 0xc0));
		}
		else {
			/* ~[gݒ */
			juliet_YMF288Mute(TRUE);
		}

		/* tOۑ */
		bRomeoMute = flag;
	}
}
}
#endif

/*
 *	ROMEO vXP[ύXpWX^Đݒ
 */
#ifdef ROMEO
static void FASTCALL ROMEO_ChangePrescaler(void)
{
	int i;

	/* PSG */
	for (i=0; i<13; i++) {
		if ((i < 7) || (i > 10)) {
			juliet_YMF288A_B((BYTE)i, opn_reg[OPN_STD][i]);
		}
	}

	/* FM */
	for (i=0xa0; i<0xb0; i++) {
		juliet_YMF288A_B((BYTE)i, opn_reg[OPN_STD][i]);
		juliet_YMF288B_B((BYTE)i, opn_reg[OPN_WHG][i]);
	}
}
#endif

/*
 *	~[gԎ擾
 */
extern "C" {
BOOL FASTCALL GetMute(int ch)
{
	return (BOOL)(nChannelMask[ch / 6] & nChannelMaskBit[ch % 6]);
}
}

/*
 *	~[gԐݒ
 */
extern "C" {
void FASTCALL SetMute(int ch, BOOL mute)
{
	/* tO̐ݒ */
	if (mute) {
		nChannelMask[ch / 6] |= (WORD)nChannelMaskBit[ch % 6];
	}
	else {
		nChannelMask[ch / 6] &= (WORD)~nChannelMaskBit[ch % 6];
	}
	
	/* fmgenɑ΂ă~[gs */
	if (pOPN[ch / 6]) {
		pOPN[ch / 6]->SetChannelMask(nChannelMask[ch / 6]);
	}
}
}

/*
 *	OPNo
 */
extern "C" {
void FASTCALL opn_notify(BYTE reg, BYTE dat)
{

	/* OPNȂ΁AȂ */
	if (!pOPN[OPN_STD]) {
		return;
	}

	/* vXP[𒲐 */
	if (opn_scale[OPN_STD] != nScale[OPN_STD]) {
		nScale[OPN_STD] = opn_scale[OPN_STD];
#ifdef ROMEO
		if (bUseRomeo) {
			ROMEO_ChangePrescaler();
		}
#endif

		switch (opn_scale[OPN_STD]) {
			case 2:
				pOPN[OPN_STD]->SetReg(0x2f, 0);
				break;
			case 3:
				pOPN[OPN_STD]->SetReg(0x2e, 0);
				break;
			case 6:
				pOPN[OPN_STD]->SetReg(0x2d, 0);
				break;
		}
	}

	/* Ch3샂[h`FbN */
	if (reg == 0x27) {
		if (uCh3Mode[OPN_STD] == dat) {
			return;
		}
		uCh3Mode[OPN_STD] = dat;
	}

	/* 0xffWX^̓`FbN */
	if (reg == 0xff) {
		if ((opn_reg[OPN_STD][0x27] & 0xc0) != 0x80) {
			return;
		}
	}

	/* TEh */
	AddSnd(FALSE, FALSE);

	/* o */
	pOPN[OPN_STD]->SetReg((uint8)reg, (uint8)dat);

	/* ݂o */
#ifdef ROMEO
	if (bUseRomeo) {
		juliet_YMF288A_B(reg, dat);
	}
#endif
}
}

/*
 *	WHGo
 */
extern "C" {
void FASTCALL whg_notify(BYTE reg, BYTE dat)
{
	/* WHGȂ΁AȂ */
	if (!pOPN[OPN_WHG]) {
		return;
	}

	/* vXP[𒲐 */
	if (opn_scale[OPN_WHG] != nScale[OPN_WHG]) {
		nScale[OPN_WHG] = opn_scale[OPN_WHG];
#ifdef ROMEO
		if (bUseRomeo) {
			ROMEO_ChangePrescaler();
		}
#endif

		switch (opn_scale[OPN_WHG]) {
			case 2:
				pOPN[OPN_WHG]->SetReg(0x2f, 0);
				break;
			case 3:
				pOPN[OPN_WHG]->SetReg(0x2e, 0);
				break;
			case 6:
				pOPN[OPN_WHG]->SetReg(0x2d, 0);
				break;
		}
	}

	/* Ch3샂[h`FbN */
	if (reg == 0x27) {
		if (uCh3Mode[OPN_WHG] == dat) {
			return;
		}
		uCh3Mode[OPN_WHG] = dat;
	}

	/* 0xffWX^̓`FbN */
	if (reg == 0xff) {
		if ((opn_reg[OPN_WHG][0x27] & 0xc0) != 0x80) {
			return;
		}
	}

	/* TEh */
	AddSnd(FALSE, FALSE);

	/* o */
	pOPN[OPN_WHG]->SetReg((uint8)reg, (uint8)dat);

	/* ݂o */
#ifdef ROMEO
	if (bUseRomeo && ((reg >= 0x20) && (reg <= 0xfe))) {
		juliet_YMF288B_B(reg, dat);
	}
#endif
}
}

/*
 *	THGo
 */
extern "C" {
void FASTCALL thg_notify(BYTE reg, BYTE dat)
{
	/* THGȂ΁AȂ */
	if (!pOPN[OPN_THG]) {
		return;
	}

	/* vXP[𒲐 */
	if (opn_scale[OPN_THG] != nScale[OPN_THG]) {
		nScale[OPN_THG] = opn_scale[OPN_THG];

		switch (opn_scale[OPN_THG]) {
			case 2:
				pOPN[OPN_THG]->SetReg(0x2f, 0);
				break;
			case 3:
				pOPN[OPN_THG]->SetReg(0x2e, 0);
				break;
			case 6:
				pOPN[OPN_THG]->SetReg(0x2d, 0);
				break;
		}
	}

	/* Ch3샂[h`FbN */
	if (reg == 0x27) {
		if (uCh3Mode[OPN_THG] == dat) {
			return;
		}
		uCh3Mode[OPN_THG] = dat;
	}

	/* 0xffWX^̓`FbN */
	if (reg == 0xff) {
		if ((opn_reg[OPN_THG][0x27] & 0xc0) != 0x80) {
			return;
		}
	}

	/* TEh */
	AddSnd(FALSE, FALSE);

	/* o */
	pOPN[OPN_THG]->SetReg((uint8)reg, (uint8)dat);
}
}

/*
 *	BEEPo
 */
extern "C" {
void FASTCALL beep_notify(void)
{
	/* o͏ԂωĂȂ΃^[ */
	if (!((beep_flag & speaker_flag) ^ bBeepFlag)) {
		return;
	}

	/* TEh */
	AddSnd(FALSE, FALSE);

	/* tOێ */
	if (beep_flag && speaker_flag) {
		bBeepFlag = TRUE;
	}
	else {
		bBeepFlag = FALSE;
	}
}
}

/*
 *	L[GR[_BEEPo
 */
#if XM7_VER >= 2
extern "C" {
void FASTCALL keyencbeep_notify(void)
{
	/* o͏ԂωĂȂ΃^[ */
	if (!(keyenc_beep_flag ^ bKeyEncBeepFlag)) {
		return;
	}

	/* TEh */
	AddSnd(FALSE, FALSE);

	/* tOێ */
	if (keyenc_beep_flag) {
		bKeyEncBeepFlag = TRUE;
	}
	else {
		bKeyEncBeepFlag = FALSE;
	}
}
}
#endif

/*
 *	e[vo
 */
extern "C" {
void FASTCALL tape_notify(BOOL flag)
{
	/* o͏Ԃω`FbN */
	if (bTapeFlag == flag) {
		return;
	}

	if (bTapeMon) {
		/* TEh */
		AddSnd(FALSE, FALSE);
	}

	/* tOێ */
	bTapeFlag = flag;
}
}

/*
 *	WAVo
 */
#ifdef FDDSND
extern "C" {
void FASTCALL wav_notify(BYTE no)
{
	int i;
	int j;
	DWORD k;

	/* TEh */
	AddSnd(FALSE, FALSE);

	if (no == SOUND_STOP) {
		/* ~ */
		for (i=0; i<SNDBUF; i++) {
			WavP[i].bPlay = FALSE;
		}
	}
	else {
		if (Wav[no].freq) {
			j = 0;
			k = 0;
			for (i=0; i<SNDBUF; i++) {
				/* Đ~̃`l */
				if (!WavP[i].bPlay) {
					j = i;
					break;
				}
				else {
					/* ԍŏɍĐJnꂽ`l */
					if (k < WavP[i].dwCount3) {
						k = WavP[i].dwCount3;
						j = i;
					}
				}
			}

			/* f[^Zbg */
			WavP[j].dwWaveNo	= no;
			WavP[j].dwCount1	= 0;
			WavP[j].dwCount2	= 0;
			WavP[j].dwCount3	= 0;
			WavP[j].bPlay		= TRUE;
		}
	}
}
}
#endif

#endif	/* _WIN32 */
