/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ Win32API TuEBhEP ]
 *
 *	RHG
 *	  2002.03.06	ReLXgj[̃u[N|Cgݒ@\
 *					_vEBhẼXN[o[hbOƂ
 *					$FF80`$FFFF̓e\łȂC
 *	  2002.03.10	tAZuEBhẼXN[o[C($FFEF܂)
 *	  2002.05.04	tAZuEBhEɋ|̋Wv@\ǉ
 *					tAZuƃ_ṽReLXgj[Ɨ
 *	  2002.05.23	tAZuEBhEPCݒƗ
 *	  2002.09.12	tAZuE_vEBhẼTCYύXɑΉ
 *					_vEBhEDPEI/Öւ̃Wv@\ǉ
 *					tAZuEBhẼXN[o[ďC
 *	  2002.10.04	DrawWindowTextn֐ł̃TCYꍇ̈S
 *	  2003.01.10	_vEBhEASCIILN^\E`FbNT
 *					ǉEEBhẼTCY
 *	  2003.01.26	_vEBhEɊ\EeύX@\ǉ
 *					CPUWX^EBhEɃReLXgj[EWX^e
 *					ύX@\ǉ
 *	  2003.01.27	_vEBhEɃ@\ǉ
 *					tAZuE_vEBhEɃX^bNWvE
 *					u[N|CgWv@\ǉ
 *	  2003.03.21	TileWindows/CascadeWindows̃TCYύXC
 *	  2003.05.09	CPUWX^EtAZuE_vEBhȆΏ
 *					CPU
 *					񊿎[hASCII_vł0x80̕\C
 *	  2003.07.17	eύXɃ_vEBhE̓eXV
 *					ȂC
 *	  2003.11.21	3ȏCPU({ʐMJ[hƂXeI~[WbN{b
 *					NXƂ)ɑΉł悤ɏ܂(
 *	  2004.09.18	_vEChẼy[WAbv/_EɃEChE
 *					TCYɍ킹ăAbv/_Eω悤ɕύX
 *	  2012.03.06	XPW[EBhE̕`揈ɃCxgI
 *					ASSERTɈC
 *	  2015.03.12	_vEChE̕AhXΉ
 *	  2015.03.13	TuEChẼ|bvAbvΉ
 *	  2015.11.13	AhXqXg𕨗AhX/_AhXʂɎ悤ύX
 */

#ifdef _WIN32

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <mmsystem.h>
#include <assert.h>
#include <stdlib.h>
#include "xm7.h"
#include "event.h"
#include "mmr.h"
#include "jsubsys.h"
#include "mouse.h"
#include "w32.h"
#include "w32_res.h"
#include "w32_sch.h"
#include "w32_sub.h"
#include "w32_kbd.h"

/*
 *	O[o [N
 */
HWND hSubWnd[SWND_MAXNUM];				/* TuEChE */
BOOL bShowSubWindow[SWND_MAXNUM];		/* TuEBhE\ */
BOOL bPopupSwnd = TRUE;					/* TuEBhE|bvAbv */

/*
 *	X^eBbN [N
 */
static DWORD AddrHistoryPhys[16];		/* AhX AhXqXg */
static DWORD AddrBufPhys;				/* AhX AhXobt@ */
static int AddrNumPhys;					/* AhX AhXqXg */
static BYTE nAddrDlgCPU;				/* AhXݒΏCPU */
static BOOL bAddrDlgLinearAddr;			/* AhXݒΏۃ */
static WORD AddrHistoryLogi[16];		/* _AhX AhXqXg */
static WORD AddrBufLogi;				/* _AhX AhXobt@ */
static int AddrNumLogi;					/* _AhX AhXqXg*/

static BYTE nBreakCPU;					/* u[N|Cg ݒΏCPU */
static BYTE *pBreakPoint;				/* u[N|Cg Drawobt@ */
static HMENU hBreakPoint;				/* u[N|Cg j[nh */
static POINT PosBreakPoint;				/* u[N|Cg }EXʒu */
static BYTE *pScheduler;				/* XPW[ Drawobt@ */
static DWORD dwSchedulerTime[2];		/* XPW[  */
static DWORD dwSchedulerFrame[2];		/* XPW[ t[ */
static BYTE *pCPURegister[MAXCPU];		/* CPUWX^ Drawobt@ */
static HMENU hCPURegister[MAXCPU];		/* CPUWX^ j[nh */
static BYTE *pDisAsm[MAXCPU];			/* tAZu Drawobt@ */
static DWORD dwDisAsm[MAXCPU];			/* tAZu AhX */
static HMENU hDisAsm[MAXCPU];			/* tAZu j[nh */
static POINT PosDisAsmPoint;			/* tAZu }EXʒu */
static BYTE nHeightDisAsm[MAXCPU];		/* tAZu EBhEcTCY */
static BOOL bDisPhysicalAddr;			/* tAZu AhX[h */
static BYTE *pMemory[MAXCPU];			/* _v Drawobt@ */
static DWORD dwMemory[MAXCPU];			/* _v AhX */
static HMENU hMemory[MAXCPU];			/* _v j[nh */
static BYTE nHeightMemory[MAXCPU];		/* _v EBhEcTCY */
static BOOL bAsciiDump[MAXCPU];			/* _v ASCII\ */
static BOOL bKanjiDump[MAXCPU];			/* _v \ */
static BOOL bDumpPhysicalAddr;			/* _v AhX[h */
#if XM7_VER >= 3
static BOOL bExtendMMRMode;				/* _v gMMR[h */
#endif
#if XM7_VER >= 2
static int nFM7Ver;						/* _v @ʕۑ̈ */
#else
static int nFMsubtype;					/* _v @ʕۑ̈ */
#endif
static BYTE nMemDlgCPU;					/* ύX ύXΏCPU */
static DWORD dwMemDlgAddr;				/* ύX AhX */
static WORD nMemDlgByte;				/* ύX AhXe */
static BYTE nRegDlgCPU;					/* WX^ύX ύXΏCPU */
static BYTE nRegDlgNo;					/* WX^ύX ύXΏۃWX^ */
static BYTE nMemSrchCPU;				/*  ΏCPU */
static DWORD dwMemSrchAddr;				/*  JnAhX */
static DWORD dwMemSrchAddrSave[MAXCPU];	/*  JnAhX main */
static char szMemSrchString[128];		/*  Ώۃf[^ */
static WORD wStackAddr[16];				/* VXeX^bNWvAhX */
static WORD wBreakAddr[16];				/* u[N|CgWvAhX */

/*
 *	vg^Cv錾
 */
static void FASTCALL PaintMemory(HWND hWnd);

/*
 *	VtgJIS}N+ӂ
 */
#define isKanji(p)	((BYTE)((p ^ 0x20) - 0xa1) <= 0x3b)
#define isKanji2(p)	(((BYTE)(p + 3) >= 0x43) && (p != 0x7f))
#define isJapanese	(PRIMARYLANGID(GetUserDefaultLangID()) == LANG_JAPANESE)

/*-[ ėpEBhE ]----------------------------------------------------*/

/*
 *	TuEBhE
 *	TCYύX
 */
static void FASTCALL WindowSizing(HWND hWnd, LPRECT rect, BYTE **buf)
{
	RECT wrect;
	POINT tpoint;
	POINT bpoint;
	int tframe;
	int bframe;
	int x;
	int y;
	BYTE *p;

	/* t[E^Cgo[̃TCY擾 */
	bframe = GetSystemMetrics(SM_CYSIZEFRAME);
	tframe = GetSystemMetrics(SM_CYCAPTION) + bframe;

	/* VNCAg̈vZ */
	tpoint.x = 0;
	tpoint.y = rect->top + tframe;
	bpoint.x = 0;
	bpoint.y = rect->bottom - bframe;
	ScreenToClient(hWnd, &tpoint);
	ScreenToClient(hWnd, &bpoint);

	/* NCAg̈𕶎̔{ɍ킹 */
	tpoint.y = (tpoint.y / lCharHeight) * lCharHeight;
	bpoint.y = (bpoint.y / lCharHeight) * lCharHeight;

	/* XN[W֕ϊ */
	ClientToScreen(hWnd, &tpoint);
	ClientToScreen(hWnd, &bpoint);

	/* EBhETCY𒲐 */
	GetWindowRect(hWnd, &wrect);
	rect->left = wrect.left;
	rect->top = tpoint.y;
	rect->right = wrect.right;
	rect->bottom = bpoint.y;
	x = rect->right / lCharWidth;
	y = rect->bottom / lCharHeight;

	/* ĉݒ(AdjustWindowRectɌ̒l) */
	if (bPopupSwnd) {
		AdjustWindowRect(rect,	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU |
								WS_CAPTION | WS_VISIBLE | 
								WS_MINIMIZEBOX | WS_SIZEBOX, FALSE);
	}
	else {
		AdjustWindowRect(rect,	WS_CHILD | WS_OVERLAPPED | WS_SYSMENU |
								WS_CAPTION | WS_VISIBLE | 
								WS_MINIMIZEBOX | WS_CLIPSIBLINGS | 
								WS_SIZEBOX, FALSE);
	}
	rect->left = wrect.left;
	rect->right = wrect.right;

	/* obt@Ď擾A0xFFŖ߂ */
	p = realloc(*buf, 2 * x * y);
	ASSERT(p);
	*buf = p;
	memset(p, 0xff, 2 * x * y);
}

/*
 *	TuEBhE
 *	eLXg`
 */
void FASTCALL DrawWindowText(HDC hDC, BYTE *ptr, int x, int y)
{
	BYTE *p;
	BYTE *q;
	int xx, yy;
	HFONT hBackup;

	/* tHgZNg */
	hBackup = SelectObject(hDC, hFont);

	/* r` */
	p = ptr;
	q = &p[x * y];
	for (yy=0; yy<y; yy++) {
		for (xx=0; xx<x; xx++) {
			if (ptr) {
				if (*p != *q) {
					TextOut(hDC, xx * lCharWidth, yy * lCharHeight,
						(LPCTSTR)p, 1);
					*q = *p;
				}
				p++;
				q++;
			}
		}
	}

	/* I */
	SelectObject(hDC, hBackup);
}

/*
 *	TuEBhE
 *	eLXg` (\Ή)
 */
void FASTCALL DrawWindowTextKanji(HDC hDC, BYTE *ptr, int x, int y)
{
	BYTE *p;
	BYTE *q;
	int xx, yy;
	HFONT hBackup;

	/* tHgZNg */
	hBackup = SelectObject(hDC, hFont);

	/* r` */
	for (yy=0; yy<y; yy++) {
		for (xx=0; xx<x; xx++) {
			p = &ptr[x * yy + xx];
			q = &p[x * y];
			if (ptr) {
				if (isKanji(*p)) {
					if (*(WORD *)p != *(WORD *)q) {
						TextOut(hDC, xx * lCharWidth, yy * lCharHeight,
							(LPCTSTR)p, 2);
						*(WORD *)q = *(WORD *)p;
					}
					xx++;
				}
				else {
					if (*p != *q) {
						TextOut(hDC, xx * lCharWidth, yy * lCharHeight,
							(LPCTSTR)p, 1);
						*q = *p;
					}
				}
			}
		}
	}

	/* I */
	SelectObject(hDC, hBackup);
}

/*
 *	TuEBhE
 *	eLXg`(]t)
 */
void FASTCALL DrawWindowText2(HDC hDC, BYTE *ptr, int x, int y)
{
	BYTE *p;
	BYTE *q;
	int xx, yy;
	HFONT hBackup;
	COLORREF tcolor, bcolor;
	char dat;

	/* tHgZNg */
	hBackup = SelectObject(hDC, hFont);

	/* r` */
	p = ptr;
	q = &p[x * y];
	for (yy=0; yy<y; yy++) {
		for (xx=0; xx<x; xx++) {
			if (ptr) {
				if (*p != *q) {
					if (*p & 0x80) {
						/* ]\ */
						dat = (char)(*p & 0x7f);
						bcolor = GetBkColor(hDC);
						tcolor = GetTextColor(hDC);
						SetTextColor(hDC, bcolor);
						SetBkColor(hDC, tcolor);
						TextOut(hDC, xx * lCharWidth, yy * lCharHeight, &dat, 1);
						SetTextColor(hDC, tcolor);
						SetBkColor(hDC, bcolor);
					}
					else {
						/* ʏ\ */
						TextOut(hDC, xx * lCharWidth, yy * lCharHeight,
							(LPCTSTR)p, 1);
					}
					*q = *p;
				}
				p++;
				q++;
			}
		}
	}

	/* I */
	SelectObject(hDC, hBackup);
}

/*
 *	TuEChE
 *	WM_DESTROY
 */
void FASTCALL DestroySubWindow(HWND hWnd, BYTE **pBuf, HMENU hmenu)
{
	int i;

	/* CEChE֎ʒm */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			hSubWnd[i] = NULL;

			/* j[폜 */
			if (hmenu) {
				DestroyMenu(hmenu);
			}

			/* Drawobt@폜 */
			if (pBuf && *pBuf) {
				free(*pBuf);
				*pBuf = NULL;
			}
		}
	}

	/* h[EChEĕ` */
	InvalidateRect(hDrawWnd, NULL, FALSE);
}

/*
 *	TuEBhE
 *	ʒuZo
 */
void FASTCALL PositioningSubWindow(HWND hParent, LPRECT rect, int index)
{
	RECT wrect;

	/* TuEBhEʒuZo */
	rect->left = lCharWidth * index;
	rect->top = lCharHeight * index;
	rect->right = 0;
	rect->bottom = 0;
	if (rect->top >= 380) {
		rect->top -= 380;
	}
	if (bPopupSwnd) {
		GetWindowRect(hParent, (LPRECT)&wrect);
		rect->left += wrect.left;
		rect->top += wrect.top;
	}
}

/*-[ EBhE[N ]------------------------------------------------*/

/*
 *	TuEBhE
 *	[N
 */
void FASTCALL InitSubWndWork(void)
{
	int i;

	for (i=0; i<MAXCPU; i++) {
		nHeightDisAsm[i] = 8;			/* tAZu EBhEcTCY */
		nHeightMemory[i] = 8;			/* _v EBhEcTCY */
		bAsciiDump[i] = FALSE;			/* _v ASCII\ */
		bKanjiDump[i] = FALSE;			/* _v \ */
		dwMemSrchAddrSave[i] = 0;		/*  JnAhX */
	}
	bDisPhysicalAddr = FALSE;
	bDumpPhysicalAddr = FALSE;
}

/*-[ ̂Ăʂ ]----------------------------------------------------------*/

/*
 *	[hԎ擾
 */
static BOOL FASTCALL isLinearAddrMode(BOOL bPhysicalAddr)
{
	if (fm7_ver <= 1) {
#if XM7_VER == 1
		if (fm_subtype != FMSUB_FM77) {
			return FALSE;
		}
#else
		return FALSE;
#endif
	}

	return bPhysicalAddr;
}

/*
 *	eύX_CAOȆ
 *	ő僁Ԏ擾
 */
static DWORD FASTCALL GetMaxMemArea(BOOL bPhysicalAddr)
{
	if (fm7_ver <= 1) {
#if XM7_VER == 1
		if ((fm_subtype != FMSUB_FM77) || !bPhysicalAddr) {
			return 0x10000;
		}
		else {
			return 0x40000;
		}
#else
		return 0x10000;
#endif
	}
	else if ((fm7_ver <= 2) && bPhysicalAddr) {
		return 0x40000;
	}
#if XM7_VER >= 3
	else if (isLinearAddrMode(bPhysicalAddr)) {
		if (mmr_ext) {
			return 0x100000;
		}
		else {
			return 0x40000;
		}
	}
#endif

	return 0x10000;
}

/*-[ AhXqXg ]------------------------------------------------------*/

/*
 *	AhXqXg
 *	R{{bNXւ̑}
 */
static void FASTCALL InsertHistory(HWND hWnd, BOOL bIsLinearAddr)
{
	int i;
	char string[128];

	/* qXg} */
	(void)ComboBox_ResetContent(hWnd);
	if ((nAddrDlgCPU == MAINCPU) && isLinearAddrMode(bIsLinearAddr)) {
		for (i=AddrNumPhys; i>0; i--) {
			_snprintf(string, sizeof(string), "%05X",
			AddrHistoryPhys[i - 1] &
				(GetMaxMemArea(bIsLinearAddr) - 1));
			(void)ComboBox_AddString(hWnd, string);
		}
	}
	else {
		for (i=AddrNumLogi; i>0; i--) {
			_snprintf(string, sizeof(string), "%04X", AddrHistoryLogi[i - 1]);
			(void)ComboBox_AddString(hWnd, string);
		}
	}
}

/*
 *	AhXqXg
 *	ǉ
 */
static void FASTCALL AddAddrHistory(DWORD addr, BOOL bIsLinearAddr)
{
	int i;

	/* do^`FbN */
	if ((nAddrDlgCPU == MAINCPU) && isLinearAddrMode(bIsLinearAddr)) {
		for (i=0; i<AddrNumPhys; i++) {
			if (AddrHistoryPhys[i] == addr) {
				return;
			}
		}

		/* qXgVtgA}AJEgAbv */
		for (i=14; i>=0; i--) {
			AddrHistoryPhys[i + 1] = AddrHistoryPhys[i];
		}
		AddrHistoryPhys[0] = addr;
		if (AddrNumPhys < 16) {
			AddrNumPhys++;
		}
	}
	else {
		/* do^`FbN */
		for (i=0; i<AddrNumLogi; i++) {
			if (AddrHistoryLogi[i] == (WORD)(addr & 0xffff)) {
				return;
			}
		}

		/* qXgVtgA}AJEgAbv */
		for (i=14; i>=0; i--) {
			AddrHistoryLogi[i + 1] = AddrHistoryLogi[i];
		}
		AddrHistoryLogi[0] = (WORD)(addr & 0xffff);
		if (AddrNumLogi < 16) {
			AddrNumLogi++;
		}
	}
}

/*-[ AhX̓_CAO ]------------------------------------------------*/

/*
 *	AhX̓_CAO
 *	_CAO
 */
static BOOL FASTCALL AddrDlgInit(HWND hDlg)
{
	HWND hWnd;
	RECT prect;
	RECT drect;
	char string[128];

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_ADDRCOMBO);
	ASSERT(hWnd);
	InsertHistory(hWnd, bAddrDlgLinearAddr);

	/* AhXݒ */
	if ((nAddrDlgCPU == MAINCPU) && isLinearAddrMode(bAddrDlgLinearAddr)) {
		_snprintf(string, sizeof(string), "%05X",
			AddrBufPhys & (GetMaxMemArea(bAddrDlgLinearAddr)-1));
	}
	else {
		_snprintf(string, sizeof(string), "%04X", AddrBufLogi);
	}
	ComboBox_SetText(hWnd, string);

	return TRUE;
}

/*
 *	AhX̓_CAO
 *	_CAOOK
 */
static void FASTCALL AddrDlgOK(HWND hDlg)
{
	DWORD addr;
	HWND hWnd;
	char string[128];

	ASSERT(hDlg);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_ADDRCOMBO);
	ASSERT(hWnd);

	/* ݂̒l擾 */
	ComboBox_GetText(hWnd, string, sizeof(string) - 1);
	addr = (DWORD)strtol(string, NULL, 16);
	if ((nAddrDlgCPU == MAINCPU) && bAddrDlgLinearAddr) {
		AddrBufPhys = (addr & (GetMaxMemArea(bAddrDlgLinearAddr) - 1));
		AddAddrHistory(AddrBufPhys, bAddrDlgLinearAddr);
	}
	else {
		AddrBufLogi = (WORD)(addr & 0xffff);
		AddAddrHistory(AddrBufLogi, FALSE);
	}
}

/*
 *	AhX̓_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK AddrDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return AddrDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						AddrDlgOK(hDlg);
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	AhX
 */
static BOOL FASTCALL AddrDlg(HWND hWnd, DWORD *pAddr, BYTE nCPU,
							 BOOL bLinearAddr)
{
	int ret;

	ASSERT(hWnd);
	ASSERT(pAddr);

	/* AhX[hZbg */
	bAddrDlgLinearAddr = bLinearAddr;

	/* AhXZbg */
	if ((nCPU == MAINCPU) && bAddrDlgLinearAddr) {
		AddrBufPhys = *pAddr;
	}
	else {
		AddrBufLogi = *(WORD *)pAddr;
	}

	/* [__CAOs */
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_ADDRDLG), hWnd, AddrDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}

	/* AhXZbgAA */
	if ((nCPU == MAINCPU) && bAddrDlgLinearAddr) {
		*pAddr = AddrBufPhys;
	}
	else {
		*(WORD *)pAddr = AddrBufLogi;
	}

	return TRUE;
}

/*-[ u[N|Cgݒ_CAO ]----------------------------------------*/

/*
 *	u[N|Cgݒ_CAO
 *	_CAO
 */
static BOOL FASTCALL BreakPointDlgInit(HWND hDlg)
{
	HWND hWnd;
	RECT prect;
	RECT drect;
	char string[128];

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_BREAKP_ADDRCOMBO);
	ASSERT(hWnd);
	InsertHistory(hWnd, FALSE);

	/* AhXݒ */
	_snprintf(string, sizeof(string), "%04X", AddrBufLogi);
	ComboBox_SetText(hWnd, string);

	/* ΏCPUݒ */
	switch (nBreakCPU) {
		case MAINCPU :	CheckDlgButton(hDlg, IDC_BREAKP_CPU_MAIN, BST_CHECKED);
						break;
		case SUBCPU :	CheckDlgButton(hDlg, IDC_BREAKP_CPU_SUB, BST_CHECKED);
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	CheckDlgButton(hDlg, IDC_BREAKP_CPU_JSUB, BST_CHECKED);
						break;
#endif
	}

	return TRUE;
}

/*
 *	u[N|Cgݒ_CAO
 *	_CAOOK
 */
static void FASTCALL BreakPointDlgOK(HWND hDlg)
{
	HWND hWnd;
	char string[128];

	ASSERT(hDlg);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_BREAKP_ADDRCOMBO);
	ASSERT(hWnd);

	/* ΏCPU擾 */
	if (IsDlgButtonChecked(hDlg, IDC_BREAKP_CPU_MAIN) == BST_CHECKED) {
		nBreakCPU = MAINCPU;
	}
#if ((XM7_VER == 1) && defined(JSUB))
	else if (IsDlgButtonChecked(hDlg, IDC_BREAKP_CPU_JSUB) == BST_CHECKED) {
		nBreakCPU = JSUBCPU;
	}
#endif
	else {
		nBreakCPU = SUBCPU;
	}

	/* ݂̒l擾 */
	ComboBox_GetText(hWnd, string, sizeof(string) - 1);
	AddrBufLogi = (WORD)strtol(string, NULL, 16);

	/* qXgǉ */
	AddAddrHistory(AddrBufLogi, FALSE);
}

/*
 *	u[N|Cgݒ_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK BreakPointDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return BreakPointDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						BreakPointDlgOK(hDlg);
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	u[N|Cgݒ
 */
static BOOL FASTCALL BreakPointDlg(HWND hWnd, int num)
{
	int ret;

	ASSERT(hWnd);

	/* AhXZbg */
	if (breakp[num].flag != BREAKP_NOTUSE) {
		AddrBufLogi = breakp[num].addr;
		nBreakCPU = (BYTE)breakp[num].cpu;
	}
	else {
		AddrBufLogi = 0;
		nBreakCPU = MAINCPU;
	}

	/* [__CAOs */
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_BREAKPDLG), hWnd, BreakPointDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}

	/* AhXZbgAA */
	schedule_setbreak2(num, nBreakCPU, (WORD)AddrBufLogi);
	return TRUE;
}

/*-[ u[N|Cg ]------------------------------------------------------*/

/*
 *	u[N|CgEChE
 *	ZbgAbv
 */
static void FASTCALL SetupBreakPoint(BYTE *p, int x, int y)
{
	int i;
	char string[128];
	char tmp[128];

	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* VMbN */
	LockVM();

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);

	/* u[N|Cg[v */
	for (i=0; i<BREAKP_MAXNUM; i++) {
		/* 쐬 */
		string[0] = '\0';
		if (breakp[i].flag == BREAKP_NOTUSE) {
			_snprintf(string, sizeof(string), "%2d ------------------", i + 1);
		}
		else {
			switch (breakp[i].cpu) {
				case MAINCPU :	strncpy(tmp, "Main", sizeof(tmp));
								break;
				case SUBCPU :	strncpy(tmp, "Sub ", sizeof(tmp));
								break;
#if ((XM7_VER == 1) && defined(JSUB))
				case JSUBCPU :	strncpy(tmp, "Jsub", sizeof(tmp));
								break;
#endif
			}
			_snprintf(string, sizeof(string), "%2d %s %04X ",
				i + 1, tmp, breakp[i].addr);
			switch (breakp[i].flag) {
				case BREAKP_ENABLED:
					strncat(string, " Enabled", sizeof(string) - strlen(string) - 1);
					break;
				case BREAKP_DISABLED:
					strncat(string, "Disabled", sizeof(string) - strlen(string) - 1);
					break;
			}
		}

		/* Rs[ */
		memcpy(&p[x * i], string, strlen(string));
	}

	/* VMAbN */
	UnlockVM();
}

/*
 *	u[N|CgEChE
 *	`
 */
static void FASTCALL DrawBreakPoint(HWND hWnd, HDC hDC)
{
	RECT rect;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	if (!pBreakPoint) {
		return;
	}
	SetupBreakPoint(pBreakPoint, x, y);

	/* ` */
	DrawWindowText(hDC, pBreakPoint, x, y);
}

/*
 *	u[N|CgEChE
 *	tbV
 */
void FASTCALL RefreshBreakPoint(void)
{
	HWND hWnd;
	HDC hDC;

	/* ɌĂ΂̂ŁA݃`FbN邱 */
	if (hSubWnd[SWND_BREAKPOINT] == NULL) {
		return;
	}

	/* ` */
	hWnd = hSubWnd[SWND_BREAKPOINT];
	hDC = GetDC(hWnd);
	DrawBreakPoint(hWnd, hDC);
	ReleaseDC(hWnd, hDC);
}

/*
 *	u[N|CgEChE
 *	ĕ`
 */
static void FASTCALL PaintBreakPoint(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* |C^ݒ(݂ȂΉȂ) */
	p = pBreakPoint;
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawBreakPoint(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	u[N|Cg
 *	R}h
 */
static void FASTCALL CmdBreakPoint(HWND hWnd, WORD wID)
{
	int num;
	POINT point;

	ASSERT(hWnd);

	/* CfbNXԍ擾 */
	point = PosBreakPoint;
	num = point.y / lCharHeight;
	if ((num < 0) || (num >= BREAKP_MAXNUM)) {
		return;
	}

	/* R}h */
	switch (wID) {
		/* Wv */
		case IDM_BREAKP_JUMP:
			if (breakp[num].flag != BREAKP_NOTUSE) {
				AddrDisAsm((BYTE)breakp[num].cpu, breakp[num].addr);
			}
			break;

		/* ݒ */
		case IDM_BREAKP_SET:
			BreakPointDlg(hWnd, num);
			break;

		/* Cl[u */
		case IDM_BREAKP_ENABLE:
			if (breakp[num].flag == BREAKP_DISABLED) {
				breakp[num].flag = BREAKP_ENABLED;
				InvalidateRect(hWnd, NULL, FALSE);
				RefreshDisAsm();
			}
			break;

		/* fBZ[u */
		case IDM_BREAKP_DISABLE:
			if (breakp[num].flag == BREAKP_ENABLED) {
				breakp[num].flag = BREAKP_DISABLED;
				InvalidateRect(hWnd, NULL, FALSE);
				RefreshDisAsm();
			}
			break;

		/* NA */
		case IDM_BREAKP_CLEAR:
			if (breakp[num].flag != BREAKP_NOTUSE) {
				schedule_setbreak(breakp[num].cpu, breakp[num].addr);
			}
			InvalidateRect(hWnd, NULL, FALSE);
			RefreshDisAsm();
			break;

		/* SăNA */
		case IDM_BREAKP_ALL:
			for (num=0; num<BREAKP_MAXNUM; num++) {
				if (breakp[num].flag != BREAKP_NOTUSE) {
					schedule_setbreak(breakp[num].cpu, breakp[num].addr);
				}
			}
			InvalidateRect(hWnd, NULL, FALSE);
			RefreshDisAsm();
			break;
	}
}

/*
 *	u[N|CgEChE
 *	EChEvV[W
 */
static LRESULT CALLBACK BreakPointProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	POINT point;
	int i;
	HMENU hMenu;

	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintBreakPoint(hWnd);
			UnlockVM();
			return 0;

		/* NbN */
		case WM_LBUTTONDOWN:
		case WM_LBUTTONDBLCLK:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* J[\ʒuA */
			i = HIWORD(lParam) / lCharHeight;
			if ((i >= 0) && (i < BREAKP_MAXNUM)) {
				if (breakp[i].flag != BREAKP_NOTUSE) {
					AddrDisAsm((BYTE)breakp[i].cpu, breakp[i].addr);
				}
			}
			return 0;

		/* ReLXgj[ */
		case WM_RBUTTONDOWN:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			PosBreakPoint = point;
			hMenu = GetSubMenu(hBreakPoint, 0);
			ClientToScreen(hWnd, &point);
			TrackPopupMenu(hMenu, 0, point.x, point.y, 0, hWnd, NULL);
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* j[폜 */
			DestroyMenu(hBreakPoint);

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pBreakPoint, NULL);

			UnlockVM();
			break;

		/* R}h */
		case WM_COMMAND:
			CmdBreakPoint(hWnd, LOWORD(wParam));
			break;
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	u[N|CgEChE
 *	EChE쐬
 */
HWND FASTCALL CreateBreakPoint(HWND hParent, int index)
{
	WNDCLASSEX wcex;
	char szClassName[] = "XM7_BreakPoint";
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	DWORD dwStyle;

	ASSERT(hParent);

	/* EChE`vZ */
	PositioningSubWindow(hParent, &rect, index);
	rect.right = lCharWidth * 21;
	rect.bottom = lCharHeight * BREAKP_MAXNUM;

	/* EChE^CgAobt@m */
	LoadString(hResInstance, IDS_SWND_BREAKPOINT,
				szWndName, sizeof(szWndName));
	pBreakPoint = malloc(2 * (rect.right / lCharWidth) *
								(rect.bottom / lCharHeight));

	/* j[[h */
	hBreakPoint = LoadMenu(hResInstance, MAKEINTRESOURCE(IDR_BREAKPOINTMENU));

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW;
	wcex.lpfnWndProc = BreakPointProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
	if (bPopupSwnd) {
		dwStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_BORDER;
	}
	else {
		dwStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);
	}

	/* ʂA */
	return hWnd;
}

/*-[ XPW[EChE ]------------------------------------------------*/

static char *pszSchedulerTitle[] = {
	"Main Timer",
	"Sub  Timer",
	"OPN Timer A",
	"OPN Timer B",
	"Key Repeat",
	"BEEP",
	"V-SYNC",
	"V/H-BLANK",
#if XM7_VER >= 2
	"Line LSI",
	"RTC Clock",	/* V3.2L02` */
#else
	"Text Blink",
	"(Reserved)",
#endif
	"WHG Timer A",
	"WHG Timer B",
	"THG Timer A",
	"THG Timer B",
	"FDC (M.Sec)",
	"FDC (Lost)",
	"FDD (Seek)",
	"Tape Sound",
#ifdef MOUSE
	"Mouse Lost",
#else
	"(Reserved)",
#endif
#if XM7_VER >= 3
	"DMA Start",
#else
	"(Reserved)",
#endif
#if XM7_VER >= 2
	"KeyEnc ACK",
#else
	"(Reserved)",
#endif
#ifdef RSC
	"RS TxTiming",
	"RS RxTiming",
#else
	"(Reserved)",
	"(Reserved)",
#endif
#if XM7_VER >= 2
	"KeyEnc BEEP",
	"KeyEnc MSG",
#else
	"(Reserved)",
	"(Reserved)",
#endif
#ifdef MOUSE
	"PTM Timer",
#else
	"(Reserved)",
#endif
	"(Reserved)",
	"(Reserved)",
};

/*
 *	XPW[EChE
 *	ZbgAbv
 */
static void FASTCALL SetupScheduler(BYTE *p, int x, int y)
{
	int i;
	int j;
	char string[128];
	DWORD dwFrame;
	DWORD dwTime;

	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* VMbN */
	LockVM();

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);

	/* s */
	_snprintf(string, sizeof(string), "Execute Time %12d ms",
		dwExecTotal / 1000);
	memcpy(p, string, strlen(string));

	/* t[g[^ */
	dwFrame = dwDrawTotal - dwSchedulerFrame[0];
	dwTime = timeGetTime() - dwSchedulerTime[0];
	if (dwTime > 0) {
		dwFrame = dwFrame * 100000 / dwTime;
	}
	else {
		dwSchedulerTime[0] = timeGetTime();
		dwFrame = 0;
	}
	_snprintf(string, sizeof(string), "Frame Rate (Total) %3d.%02d fps",
		dwFrame / 100, dwFrame % 100);
	memcpy(&p[x * 1], string, strlen(string));

	/* t[2sec */
	dwTime = timeGetTime() - dwSchedulerTime[1];
	if (dwTime > 0) {
		dwFrame = dwDrawTotal - dwSchedulerFrame[1];
		dwFrame = dwFrame * 100000 / dwTime;
	}
	else {
		dwFrame = 0;
	}
	if ((dwTime < 0) || (dwTime > 2000)) {
		dwSchedulerTime[1] = timeGetTime();
		dwSchedulerFrame[1] = dwDrawTotal;
	}
	_snprintf(string, sizeof(string), "Frame Rate (Latest)%3d.%02d fps",
		dwFrame / 100, dwFrame % 100);
	memcpy(&p[x * 2], string, strlen(string));

	/* [v */
	j = 4;
	for (i=0; i<EVENT_MAXNUM; i++) {
		/* ^Cg */
		memcpy(&p[x * j], pszSchedulerTitle[i], strlen(pszSchedulerTitle[i]));

		/* JgA[h */
		if (event[i].flag != EVENT_NOTUSE) {
			_snprintf(string, sizeof(string), "%4d.%03dms",
				event[i].current / 1000, event[i].current % 1000);
			memcpy(&p[x * j + 12], string, strlen(string));

			_snprintf(string, sizeof(string), "(%4d.%03dms)",
				event[i].reload / 1000, event[i].reload % 1000);
			memcpy(&p[x * j + 23], string, strlen(string));

			/* Xe[^X */
			switch (event[i].flag) {
				case EVENT_ENABLED:
					strncpy(string, " Enabled", sizeof(string));
					break;

				case EVENT_DISABLED:
					strncpy(string, "Disabled", sizeof(string));
					break;

				default:
					ASSERT(FALSE);
					break;
			}
		}
		else {
			strncpy(string, "", sizeof(string));
		}

		memcpy(&p[x * j + 36], string, strlen(string));
		j++;
	}

	/* I[o[TCN */
	strncpy(string,  "|  Over Cycle", sizeof(string));
	memcpy(&p[x * 0 + 30], string, strlen(string));
	_snprintf(string, sizeof(string), "| Main %7d", main_overcycles);
	memcpy(&p[x * 1 + 30], string, strlen(string));
	_snprintf(string, sizeof(string), "| Sub  %7d", sub_overcycles);
	memcpy(&p[x * 2 + 30], string, strlen(string));

#ifdef DEBUG
	if (dwFrame == 0) {
		dwTime = 100000;
	}
	else {
		dwTime = 100000 / dwFrame;
	}

	/* (ł΂΁`p) */
	_snprintf(string, sizeof(string), "Exec Time (CPU)  %4d.%03d ms (%3d\%)",
		dwCpuExecTime / 1000, dwCpuExecTime % 1000, dwCpuExecTime / dwTime);
	memcpy(&p[x * (j + 1)], string, strlen(string));

	_snprintf(string, sizeof(string), "Exec Time (DRAW) %4d.%03d ms (%3d\%)",
		dwDrawExecTime / 1000, dwDrawExecTime % 1000, dwDrawExecTime / dwTime);
	memcpy(&p[x * (j + 2)], string, strlen(string));

	_snprintf(string, sizeof(string), "Exec Time (POLL) %4d.%03d ms (%3d\%)",
		dwPollExecTime / 1000, dwPollExecTime % 1000, dwPollExecTime / dwTime);
	memcpy(&p[x * (j + 3)], string, strlen(string));

	i = (dwTime * 100) - (dwCpuExecTime + dwDrawExecTime + dwPollExecTime);
	if (i < 0) {
		i = 0;
	}
	_snprintf(string, sizeof(string), "Idle Time        %4d.%03d ms (%3d\%)",
		i / 1000, i % 1000, i / dwTime);
	memcpy(&p[x * (j + 4)], string, strlen(string));
#endif

	/* VMAbN */
	UnlockVM();
}

/*
 *	XPW[EChE
 *	`
 */
static void FASTCALL DrawScheduler(HWND hWnd, HDC hDC)
{
	RECT rect;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	if (!pScheduler) {
		return;
	}
	SetupScheduler(pScheduler, x, y);

	/* ` */
	DrawWindowText(hDC, pScheduler, x, y);
}

/*
 *	XPW[EChE
 *	tbV
 */
void FASTCALL RefreshScheduler(void)
{
	HWND hWnd;
	HDC hDC;

	/* ɌĂ΂̂ŁA݃`FbN邱 */
	if (hSubWnd[SWND_SCHEDULER] == NULL) {
		return;
	}

	/* ` */
	hWnd = hSubWnd[SWND_SCHEDULER];
	hDC = GetDC(hWnd);
	DrawScheduler(hWnd, hDC);
	ReleaseDC(hWnd, hDC);
}

/*
 *	XPW[EChE
 *	ĕ`
 */
static void FASTCALL PaintScheduler(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* |C^ݒ(݂ȂΉȂ) */
	p = pScheduler;
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawScheduler(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	XPW[EChE
 *	EChEvV[W
 */
static LRESULT CALLBACK SchedulerProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintScheduler(hWnd);
			UnlockVM();
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pScheduler, NULL);

			UnlockVM();
			break;
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	XPW[EChE
 *	EChE쐬
 */
HWND FASTCALL CreateScheduler(HWND hParent, int index)
{
	WNDCLASSEX wcex;
	char szClassName[] = "XM7_Scheduler";
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	DWORD dwStyle;

	ASSERT(hParent);

	/* EChE`vZ */
	PositioningSubWindow(hParent, &rect, index);
	rect.right = lCharWidth * 44;
#ifdef DEBUG
	rect.bottom = lCharHeight * (EVENT_MAXNUM + 9);
#else
	rect.bottom = lCharHeight * (EVENT_MAXNUM + 4);
#endif

	/* EChE^CgAobt@m */
	LoadString(hResInstance, IDS_SWND_SCHEDULER,
				szWndName, sizeof(szWndName));
	pScheduler = malloc(2 * (rect.right / lCharWidth) *
								(rect.bottom / lCharHeight));

	/* ԁAt[ */
	dwSchedulerTime[0] = timeGetTime();
	dwSchedulerTime[1] = dwSchedulerTime[0];
	dwSchedulerFrame[0] = dwDrawTotal;
	dwSchedulerFrame[1] = dwSchedulerFrame[0];

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW;
	wcex.lpfnWndProc = SchedulerProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
	if (bPopupSwnd) {
		dwStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_BORDER;
	}
	else {
		dwStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);
	}

	/* ʂA */
	return hWnd;
}

/*-[ WX^eύX_CAO ]--------------------------------------------*/

/*
 *	WX^eύX_CAO
 *	_CAO
 */
static BOOL FASTCALL CPURegDlgInit(HWND hDlg)
{
	static const char *RegName[10] = {
		"CC", "A", "B", "DP", "D", "X", "Y", "U", "S", "PC"
	};

	HWND hWnd;
	RECT prect;
	RECT drect;
	cpu6809_t *pReg;
	char tmp[16];
	char tmp2[128];
	char string[128];
	WORD dat;
	UINT id;

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* ݒ */
	switch (nRegDlgCPU) {
		case MAINCPU :	id = IDS_SWND_CPU_MAIN;
						pReg = &maincpu;
						break;
		case SUBCPU :	id = IDS_SWND_CPU_SUB;
						pReg = &subcpu;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	id = IDS_SWND_CPU_JSUB;
						pReg = &jsubcpu;
						break;
#endif
	}
	LoadString(hResInstance, id, tmp, sizeof(tmp));

	/* AhXݒ */
	hWnd = GetDlgItem(hDlg, IDC_REGLABEL);
	ASSERT(hWnd);
	if (LoadString(hResInstance, IDS_SWND_REG_MESSAGE,
					tmp2, sizeof(tmp2)) == 0) {
		_snprintf(string, sizeof(string), "%sWX^ (%s)",
			RegName[nRegDlgNo], tmp);
	}
	else {
		_snprintf(string, sizeof(string), tmp2, RegName[nRegDlgNo], tmp);
	}
	SetWindowText(hWnd, string);

	/* f[^ݒ */
	hWnd = GetDlgItem(hDlg, IDC_REGEDIT);
	ASSERT(hWnd);
	switch (nRegDlgNo) {
		case 0:	/* CC */
				dat = pReg -> cc;
				break;
		case 1:	/* A */
				dat = pReg -> acc.h.a;
				break;
		case 2:	/* B */
				dat = pReg -> acc.h.b;
				break;
		case 3:	/* DP */
				dat = pReg -> dp;
				break;
		case 4:	/* D */
				dat = pReg -> acc.d;
				break;
		case 5:	/* X */
				dat = pReg -> x;
				break;
		case 6:	/* Y */
				dat = pReg -> y;
				break;
		case 7:	/* U */
				dat = pReg -> u;
				break;
		case 8:	/* S */
				dat = pReg -> s;
				break;
		case 9:	/* PC */
				dat = pReg -> pc;
				break;
	}
	if (nRegDlgNo < 4) {
		/* 8rbgWX^ */
		_snprintf(string, sizeof(string), "%02X", dat);
	}
	else {
		/* 16rbgWX^ */
		_snprintf(string, sizeof(string), "%04X", dat);
	}
	SetWindowText(hWnd, string);

	return TRUE;
}

/*
 *	WX^eύX_CAO
 *	_CAOOK
 */
static void FASTCALL CPURegDlgOK(HWND hDlg)
{
	HWND hWnd;
	cpu6809_t *pReg;
	char string[128];
	WORD dat;

	ASSERT(hDlg);
	LockVM();

	/* ݒ */
	switch (nRegDlgCPU) {
		case MAINCPU :	pReg = &maincpu;
						break;
		case SUBCPU :	pReg = &subcpu;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	pReg = &jsubcpu;
						break;
#endif
	}

	/* ݂̒l擾 */
	hWnd = GetDlgItem(hDlg, IDC_REGEDIT);
	ASSERT(hWnd);
	GetWindowText(hWnd, string, sizeof(string) - 1);
	dat = (WORD)strtol(string, NULL, 16);

	/* f[^ݒ */
	switch (nRegDlgNo) {
		case 0:	/* CC */
				pReg -> cc = (BYTE)dat;
				break;
		case 1:	/* A */
				pReg -> acc.h.a = (BYTE)dat;
				break;
		case 2:	/* B */
				pReg -> acc.h.b = (BYTE)dat;
				break;
		case 3:	/* DP */
				pReg -> dp = (BYTE)dat;
				break;
		case 4:	/* D */
				pReg -> acc.d = dat;
				break;
		case 5:	/* X */
				pReg -> x = dat;
				break;
		case 6:	/* Y */
				pReg -> y = dat;
				break;
		case 7:	/* U */
				pReg -> u = dat;
				break;
		case 8:	/* S */
				pReg -> s = dat;
				break;
		case 9:	/* PC */
				pReg -> pc = dat;
				break;
	}

	UnlockVM();
}

/*
 *	WX^eύX_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK CPURegDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return CPURegDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						CPURegDlgOK(hDlg);
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	WX^eύX
 */
static BOOL FASTCALL CPURegDlg(HWND hWnd, BYTE nCPU, int x, int y)
{
	int ret;

	ASSERT(hWnd);

	/* p[^ۑEݒ */
	nRegDlgCPU = nCPU;

	/* WX^ԍZbg */
	nRegDlgNo = (BYTE)(((x / 10) * 5) + y);

	/* IRWX^EW`FbN */
	if ((nRegDlgNo == 4) || ((x % 10) >= 7)) {
		return FALSE;
	}

	/* [__CAOs */
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_REGDLG), hWnd, CPURegDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}
	return TRUE;
}

/*-[ CPUWX^EChE ]-------------------------------------------------*/

/*
 *	CPUWX^EChE
 *	ZbgAbv
 */
static void FASTCALL SetupCPURegister(BYTE nCPU, BYTE *p, int x, int y)
{
	char buf[128];
	cpu6809_t *pReg;

	ASSERT(nCPU < MAXCPU);
	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);

	/* WX^obt@𓾂 */
	switch (nCPU) {
		case MAINCPU :	pReg = &maincpu;
						break;
		case SUBCPU :	pReg = &subcpu;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	pReg = &jsubcpu;
						break;
#endif
	}

	/* Zbg */
	_snprintf(buf, sizeof(buf), "CC   %02X   X  %04X", pReg->cc, pReg->x);
	memcpy(&p[0 * x + 0], buf, strlen(buf));
	_snprintf(buf, sizeof(buf), "A    %02X   Y  %04X", pReg->acc.h.a, pReg->y);
	memcpy(&p[1 * x + 0], buf, strlen(buf));
	_snprintf(buf, sizeof(buf), "B    %02X   U  %04X", pReg->acc.h.b, pReg->u);
	memcpy(&p[2 * x + 0], buf, strlen(buf));
	_snprintf(buf, sizeof(buf), "DP   %02X   S  %04X", pReg->dp, pReg->s);
	memcpy(&p[3 * x + 0], buf, strlen(buf));
	_snprintf(buf, sizeof(buf), "IR %04X   PC %04X", pReg->intr, pReg->pc);
	memcpy(&p[4 * x + 0], buf, strlen(buf));
}

/*
 *	CPUWX^EChE
 *	`
 */
static void FASTCALL DrawCPURegister(HWND hWnd, HDC hDC)
{
	int i;
	BYTE nCPU;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			nCPU = (BYTE)((i - SWND_CPUREG_MAIN) % MAXCPU);
			p = pCPURegister[nCPU];
			break;
		}
	}
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	SetupCPURegister(nCPU, p, x, y);

	/* ` */
	DrawWindowText(hDC, p, x, y);
}

/*
 *	CPUWX^EChE
 *	tbV
 */
void FASTCALL RefreshCPURegister(void)
{
	HWND hWnd;
	HDC hDC;

	/* CCPU */
	if (hSubWnd[SWND_CPUREG_MAIN]) {
		hWnd = hSubWnd[SWND_CPUREG_MAIN];
		hDC = GetDC(hWnd);
		DrawCPURegister(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

	/* TuCPU */
	if (hSubWnd[SWND_CPUREG_SUB]) {
		hWnd = hSubWnd[SWND_CPUREG_SUB];
		hDC = GetDC(hWnd);
		DrawCPURegister(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

#if ((XM7_VER == 1) && defined(JSUB))
	/* {TuCPU */
	if (hSubWnd[SWND_CPUREG_JSUB]) {
		hWnd = hSubWnd[SWND_CPUREG_JSUB];
		hDC = GetDC(hWnd);
		DrawCPURegister(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}
#endif
}

/*
 *	CPUWX^EChE
 *	ĕ`
 */
static void FASTCALL PaintCPURegister(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	int i;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			p = pCPURegister[((i - SWND_CPUREG_MAIN) % MAXCPU)];
			break;
		}
	}

	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawCPURegister(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	CPUWX^EChE
 *	EChEvV[W
 */
static LRESULT CALLBACK CPURegisterProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	HMENU hMenu;
	POINT point;
	BYTE nCPU;

	if (hSubWnd[SWND_CPUREG_MAIN] == hWnd) {
		nCPU = MAINCPU;
	}
#if ((XM7_VER == 1) && defined(JSUB))
	else if (hSubWnd[SWND_CPUREG_JSUB] == hWnd) {
		nCPU = JSUBCPU;
	}
#endif
	else {
		nCPU = SUBCPU;
	}

	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintCPURegister(hWnd);
			UnlockVM();
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pCPURegister[nCPU], hCPURegister[nCPU]);

			UnlockVM();
			break;

		/* WX^eύX */
		case WM_LBUTTONDBLCLK:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* J[\ʒuA */
			point.x = LOWORD(lParam) / lCharWidth;
			point.y = HIWORD(lParam) / lCharHeight;
			CPURegDlg(hWnd, nCPU, point.x, point.y);
			return 0;

		/* ReLXgj[ */
		case WM_CONTEXTMENU:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* ReLXgj[[h */
			hMenu = GetSubMenu(hCPURegister[nCPU], 0);

			/* ReLXgj[s */
			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			TrackPopupMenu(hMenu, 0, point.x, point.y, 0, hWnd, NULL);
			return 0;

		/* R}h */
		case WM_COMMAND:
			CPURegDlg(hWnd, nCPU, -1, LOWORD(wParam) - IDM_REG_CC);
			break;
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	CPUWX^EChE
 *	EChE쐬
 */
HWND FASTCALL CreateCPURegister(HWND hParent, BYTE nCPU, int index)
{
	WNDCLASSEX wcex;
	char szClassNameMain[] = "XM7_CPURegisterMain";
	char szClassNameSub[] = "XM7_CPURegisterSub";
#if ((XM7_VER == 1) && defined(JSUB))
	char szClassNameJsub[] = "XM7_CPURegisterJsub";
#endif
	char *szClassName;
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	UINT id;
	DWORD dwStyle;

	ASSERT(hParent);

	/* EChE`vZ */
	PositioningSubWindow(hParent, &rect, index);
	rect.right = lCharWidth * 17;
	rect.bottom = lCharHeight * 5;

	/* EChE^CgAobt@m */
	switch (nCPU) {
		case MAINCPU :	id = IDS_SWND_CPUREG_MAIN;
						szClassName = szClassNameMain;
						break;
		case SUBCPU :	id = IDS_SWND_CPUREG_SUB;
						szClassName = szClassNameSub;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	id = IDS_SWND_CPUREG_JSUB;
						szClassName = szClassNameJsub;
						break;
#endif
	}
	LoadString(hResInstance, id, szWndName, sizeof(szWndName));
	pCPURegister[nCPU] = malloc(2 * (rect.right / lCharWidth) *
							(rect.bottom / lCharHeight));
	hCPURegister[nCPU] = LoadMenu(hResInstance,
							MAKEINTRESOURCE(IDR_CPUREGMENU));

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS;
	wcex.lpfnWndProc = CPURegisterProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
	if (bPopupSwnd) {
		dwStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_BORDER;
	}
	else {
		dwStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);
	}

	/* ʂA */
	return hWnd;
}

/*-[ X^bNEu[N|CgWv ]------------------------------------*/

/*
 *	X^bNWvj[}
 */
static void FASTCALL InsertStackJumpMenu(HMENU hMenu, BYTE nCPU, UINT id)
{
	BYTE (FASTCALL *readbnio)(WORD addr);
	MENUITEMINFO mii;
	char string[128];
	WORD addr;
	int i;

	/* j[\̏ */
	memset(&mii, 0, sizeof(mii));
	mii.cbSize = 44;
	mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
	mii.fType = MFT_STRING;
	mii.fState = MFS_ENABLED;

	/* j[ׂč폜 */
	while (GetMenuItemCount(hMenu) > 0) {
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}

	/* ڂǉ */
	for (i=15; i>=0; i--) {
		mii.wID = id + i;
		switch (nCPU) {
			case MAINCPU :	readbnio = mainmem_readbnio;
							break;
			case SUBCPU :	readbnio = submem_readbnio;
							break;
#if ((XM7_VER == 1) && defined(JSUB))
			case JSUBCPU :	readbnio = jsubmem_readbnio;
							break;
#endif
		}
		addr = (WORD)(readbnio((WORD)(maincpu.s + i)) << 8);
		addr |= (WORD)readbnio((WORD)(maincpu.s + i + 1));

		wStackAddr[i] = addr;
		_snprintf(string, sizeof(string), "%d,S ($%04X)", i, addr);
		mii.dwTypeData = string;
		mii.cch = strlen(string);
		InsertMenuItem(hMenu, 0, TRUE, &mii);
	}
}

/*
 *	u[N|CgWvj[}
 */
static void FASTCALL InsertBreakPointMenu(HMENU hMenu, BYTE nCPU, UINT id)
{
	MENUITEMINFO mii;
	char string[128];
	int no;
	int i;

	/* j[\̏ */
	memset(&mii, 0, sizeof(mii));
	mii.cbSize = 44;
	mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
	mii.fType = MFT_STRING;
	mii.fState = MFS_ENABLED;

	/* j[ׂč폜 */
	while (GetMenuItemCount(hMenu) > 0) {
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}

	/* ڂǉ */
	no = 0;
	for (i=15; i>=0; i--) {
		if ((breakp[i].flag != BREAKP_NOTUSE) && (breakp[i].cpu == nCPU)) {
			mii.wID = id + no;
			wBreakAddr[no++] = breakp[i].addr;
			_snprintf(string, sizeof(string), "%d : $%04X",
				i+1, breakp[i].addr);
			mii.dwTypeData = string;
			mii.cch = strlen(string);
			InsertMenuItem(hMenu, 0, TRUE, &mii);
		}
	}
	if (no == 0) {
		/* 1u[N|CgȂꍇ */
		mii.wID = id;
		mii.fState = MFS_GRAYED;
		LoadString(hResInstance, IDS_SWND_BREAKPOINT_NONE,
				string, sizeof(string));
		mii.dwTypeData = string;
		mii.cch = strlen(string);
		InsertMenuItem(hMenu, 0, TRUE, &mii);
	}
}

/*
 *	X^bNWvj[}
 */
static void FASTCALL InsertPhysicalMemMenu(HMENU hMenu, BYTE nCPU, UINT id)
{
	MENUITEMINFO mii;
	char string[128];
	int i;

	UNUSED(nCPU);
	
	/* j[\̏ */
	memset(&mii, 0, sizeof(mii));
	mii.cbSize = 44;
	mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
	mii.fType = MFT_STRING;
	mii.fState = MFS_ENABLED;

	/* j[ׂč폜 */
	while (GetMenuItemCount(hMenu) > 0) {
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}

	/* ڂǉ */
#if XM7_VER >= 3
	if (mmr_ext) {
		i = 15;
	}
	else {
		i = 3;
	}
#else
	i = 3;
#endif
	for (; i>=0; i--) {
		mii.wID = id + i;
		_snprintf(string, sizeof(string), "$%1X0000-$%1XFFFF", i, i);
		mii.dwTypeData = string;
		mii.cch = strlen(string);
		InsertMenuItem(hMenu, 0, TRUE, &mii);
	}
}

/*-[ tAZuEChE ]------------------------------------------------*/

/*
 *	tAZuEChE
 *	AhXݒ
 */
void FASTCALL AddrDisAsm(BYTE nCPU, DWORD dwAddr)
{
	SCROLLINFO sif;
	HWND hWnd;

	/* EChEWIg𓾂 */
	hWnd = NULL;
	switch (nCPU) {
		case MAINCPU :	hWnd = hSubWnd[SWND_DISASM_MAIN];
						break;
		case SUBCPU :	hWnd = hSubWnd[SWND_DISASM_SUB];
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	hWnd = hSubWnd[SWND_DISASM_JSUB];
						break;
#endif
	}
	if (!hWnd) {
		/* EChEȂ΂̂܂܃^[ */
		return;
	}

	/* SCROLLINFO\̂̏ */
	memset(&sif, 0, sizeof(sif));
	sif.cbSize = sizeof(sif);
	sif.fMask = SIF_POS;
	sif.nPos = (int)dwAddr;

	/* ݃`FbNݒ */
	dwDisAsm[nCPU] = dwAddr;
	SetScrollInfo(hWnd, SB_VERT, &sif, TRUE);

	/* tbV */
	RefreshDisAsm();
}

/*
 *	tAZuEBhE
 *	TCY
 */
static void FASTCALL ResizeDisAsm(HWND hWnd, WORD cx, WORD cy, BYTE nCPU)
{
	RECT crect;
	RECT wrect;
	int width;

	ASSERT(hWnd);

	/* ŏ̏ꍇ́AȂ */
	if ((cx == 0) && (cy == 0)) {
		return;
	}

	/* TCYύX */
	width = 54;
	nHeightDisAsm[nCPU] = (WORD)(cy / lCharHeight);
	if (nHeightDisAsm[nCPU] < 1) {
		nHeightDisAsm[nCPU] = 1;
	}

	/* EBhE`ύX */
	GetWindowRect(hWnd, &wrect);
	GetClientRect(hWnd, &crect);
	wrect.right -= wrect.left;
	wrect.right -= crect.right;
	wrect.right += (width * lCharWidth);
	wrect.bottom -= wrect.top;
	wrect.bottom -= crect.bottom;
	wrect.bottom += (nHeightDisAsm[nCPU] * lCharHeight);
	SetWindowPos(hWnd, HWND_TOP, 0, 0, wrect.right, wrect.bottom,
							SWP_NOZORDER | SWP_NOMOVE);
}

/*
 *	tAZuEChE
 *	ZbgAbv
 */
static void FASTCALL SetupDisAsm(BYTE nCPU, BYTE *p, int x, int y)
{
	char string[128];
	char tmp[16];
	int addr;
	int i;
	int j;
	int k;
	int ret;
	WORD pc;

	ASSERT(nCPU < MAXCPU);
	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);

	/* ݒ */
	switch (nCPU) {
		case MAINCPU :	pc = maincpu.pc;
						break;
		case SUBCPU :	pc = subcpu.pc;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	pc = jsubcpu.pc;
						break;
#endif
	}
	addr = (int)dwDisAsm[nCPU];

	for (i=0; i<y; i++) {
		 /* tAZu */
		ret = disline(nCPU, (WORD)addr, string);

		/* Zbg */
		if (isLinearAddrMode(bDisPhysicalAddr) && (nCPU == MAINCPU)) {
			memcpy(&p[x * i + 9], string, strlen(string));
			_snprintf(tmp, sizeof(tmp), "%05X", mmr_trans_mmr((WORD)addr));
			memcpy(&p[x * i + 3], tmp, 5);
		}
		else {
			memcpy(&p[x * i + 3], string, strlen(string));
		}

		/* }[N */
		if (pc == addr) {
			p[x * i + 2] = '>';
		}
		for (j=0; j<BREAKP_MAXNUM; j++) {
			if (breakp[j].addr != addr) {
				continue;
			}
			if (breakp[j].cpu != nCPU) {
				continue;
			}
			if (breakp[j].flag == BREAKP_NOTUSE) {
				continue;
			}
			if (breakp[j].flag == BREAKP_DISABLED) {
				continue;
			}

			/* u[N|Cg */
			_snprintf(tmp, sizeof(tmp), "%2d", j + 1);
			memcpy(&p[x * i + 0], tmp, 2);

			/* ] */
			for (k=0; k<x; k++) {
				 p[x * i + k] = (BYTE)(p[x * i + k] | 0x80);
			}
		}

		/* ZAI[o[`FbN */
		addr += ret;
		if (addr >= 0x10000) {
			break;
		}
	}
}

/*
 *	tAZuEChE
 *	`
 */
static void FASTCALL DrawDisAsm(HWND hWnd, HDC hDC)
{
	int i;
	BYTE nCPU;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			nCPU = (BYTE)((i - SWND_CPUREG_MAIN) % MAXCPU);
			p = pDisAsm[nCPU];
			break;
		}
	}
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	SetupDisAsm(nCPU, p, x, y);

	/* ` */
	DrawWindowText2(hDC, p, x, y);
}

/*
 *	tAZuEChE
 *	tbV
 */
void FASTCALL RefreshDisAsm(void)
{
	HWND hWnd;
	HDC hDC;

	/* CCPU */
	if (hSubWnd[SWND_DISASM_MAIN]) {
		hWnd = hSubWnd[SWND_DISASM_MAIN];
		hDC = GetDC(hWnd);
		DrawDisAsm(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

	/* TuCPU */
	if (hSubWnd[SWND_DISASM_SUB]) {
		hWnd = hSubWnd[SWND_DISASM_SUB];
		hDC = GetDC(hWnd);
		DrawDisAsm(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

#if ((XM7_VER == 1) && defined(JSUB))
	/* {TuCPU */
	if (hSubWnd[SWND_DISASM_JSUB]) {
		hWnd = hSubWnd[SWND_DISASM_JSUB];
		hDC = GetDC(hWnd);
		DrawDisAsm(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}
#endif
}

/*
 *	tAZuEChE
 *	ĕ`
 */
static void FASTCALL PaintDisAsm(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	int i;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			p = pDisAsm[((i - SWND_CPUREG_MAIN) % MAXCPU)];
			break;
		}
	}

	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawDisAsm(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	tAZuEChE
 *	NbN
 */
static void FASTCALL LButtonDisAsm(HWND hWnd, POINT point, BOOL mode)
{
	char string[128];
	int addr;
	BOOL flag;
	BYTE nCPU;
	int i;
	int y;
	int ret;

	ASSERT(hWnd);

	/* sJEg𓾂 */
	y = point.y / lCharHeight;

	/* ۂɋtAZuĂ݂ */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			nCPU = (BYTE)((i - SWND_CPUREG_MAIN) % MAXCPU);
			addr = (int)dwDisAsm[nCPU];
			break;
		}
	}

	/* tAZu [v */
	for (i=0; i<y; i++) {
		ret = disline(nCPU, (WORD)addr, string);
		addr += ret;
		if (addr >= 0x10000) {
			return;
		}
	}

	if (mode) {
		/* Wv */
		switch (nCPU) {
			case MAINCPU :	maincpu.pc = (WORD)addr;
							break;
			case SUBCPU :	subcpu.pc = (WORD)addr;
							break;
#if ((XM7_VER == 1) && defined(JSUB))
			case JSUBCPU :	jsubcpu.pc = (WORD)addr;
							break;
#endif
		}
	}
	else {
		/* u[N|Cg on/off */
		flag = FALSE;
		for (i=0; i<BREAKP_MAXNUM; i++) {
			if ((breakp[i].cpu == nCPU) && (breakp[i].addr == addr)) {
				if (breakp[i].flag != BREAKP_NOTUSE) {
					breakp[i].flag = BREAKP_NOTUSE;
					flag = TRUE;
					break;
				}
			}
		}
		if (!flag) {
			schedule_setbreak(nCPU, (WORD)addr);
		}

		/* u[N|CgEChEAĕ`悷 */
		if (hSubWnd[SWND_BREAKPOINT]) {
			InvalidateRect(hSubWnd[SWND_BREAKPOINT], NULL, FALSE);
		}
	}

	/* ĕ` */
	InvalidateRect(hWnd, NULL, FALSE);
}

/*
 *	tAZuEChE
 *	R}h
 */
static void FASTCALL CmdDisAsm(HWND hWnd, WORD wID, BYTE nCPU)
{
	DWORD target;
	cpu6809_t *cpu;

	/* CPU\̌ */
	switch (nCPU) {
		case MAINCPU :	cpu = &maincpu;
						break;
		case SUBCPU :	cpu = &subcpu;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	cpu = &jsubcpu;
						break;
#endif
	}

	/* ^[QbgAhX */
	switch (wID) {
		case IDM_DIS_ADDR:
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDisPhysicalAddr)) {
				target = mmr_trans_mmr((WORD)dwDisAsm[nCPU]);
				if (!AddrDlg(hWnd, &target, nCPU, TRUE)) {
					return;
				}
				target = mmr_trans_phys_to_logi(target);
			}
			else {
				target = dwDisAsm[nCPU];
				if (!AddrDlg(hWnd, &target, nCPU, FALSE)) {
					return;
				}
				target &= (WORD)0xffff;
			}
			break;
		case IDM_DIS_PHYSADDR:
			if (nCPU == MAINCPU) {
				bDisPhysicalAddr = !bDisPhysicalAddr;
			}
			return;

		case IDM_DIS_PC:
			target = cpu->pc;
			break;
		case IDM_DIS_X:
			target = cpu->x;
			break;
		case IDM_DIS_Y:
			target = cpu->y;
			break;
		case IDM_DIS_U:
			target = cpu->u;
			break;
		case IDM_DIS_S:
			target = cpu->s;
			break;

		case IDM_DIS_RESET:
			target = (WORD)((cpu->readmem(0xfffe) << 8) | cpu->readmem(0xffff));
			break;
		case IDM_DIS_NMI:
			target = (WORD)((cpu->readmem(0xfffc) << 8) | cpu->readmem(0xfffd));
			break;
		case IDM_DIS_SWI:
			target = (WORD)((cpu->readmem(0xfffa) << 8) | cpu->readmem(0xfffb));
			break;
		case IDM_DIS_IRQ:
			target = (WORD)((cpu->readmem(0xfff8) << 8) | cpu->readmem(0xfff9));
			break;
		case IDM_DIS_FIRQ:
			target = (WORD)((cpu->readmem(0xfff6) << 8) | cpu->readmem(0xfff7));
			break;
		case IDM_DIS_SWI2:
			target = (WORD)((cpu->readmem(0xfff4) << 8) | cpu->readmem(0xfff5));
			break;
		case IDM_DIS_SWI3:
			target = (WORD)((cpu->readmem(0xfff2) << 8) | cpu->readmem(0xfff3));
			break;
		case IDM_DIS_JUMP:
			LButtonDisAsm(hWnd, PosDisAsmPoint, TRUE);
			target = cpu->pc;
			break;
		case IDM_DIS_SYNCPC:
			bSyncDisasm[nCPU] = (!bSyncDisasm[nCPU]);
			return;
		default:
			if ((wID >= IDM_DIS_STACK) && (wID <= IDM_DIS_STACK + 15)) {
				target = (WORD)wStackAddr[wID - IDM_DIS_STACK];
			}
			else if ((wID >= IDM_DIS_BREAK) && (wID <= IDM_DIS_BREAK + 15)) {
				target = (WORD)wBreakAddr[wID - IDM_DIS_BREAK];
			}
			break;
	}

	/* ݒ聕XV */
	AddrDisAsm(nCPU, (WORD)target);
}

/*
 *	tAZuEChE
 *	EChEvV[W
 */
static LRESULT CALLBACK DisAsmProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam, BYTE nCPU)
{
	static BOOL bResize = FALSE;	/* 蓮TCYtO */
	DWORD dwAddr;
	char string[128];
	int ret;
	int i;
	POINT point;
	HMENU hMenu;
	RECT rect;

	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintDisAsm(hWnd);
			UnlockVM();
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pDisAsm[nCPU], hDisAsm[nCPU]);

			UnlockVM();
			break;

		/* EChETCYύX */
		case WM_SIZE:
			if (bResize) {
				bResize = FALSE;
				ResizeDisAsm(hWnd, LOWORD(lParam), HIWORD(lParam), nCPU);
			}
			break;

		/* EChETCYύX */
		case WM_SIZING:
			WindowSizing(hWnd, (LPRECT)lParam, &pDisAsm[nCPU]);
			bResize = TRUE;
			break;

		/* EBhETCYύXbZ[W */
		case WM_WINDOWPOSCHANGING:
			bResize = TRUE;
			break;

		/* ŏTCY */
		case WM_GETMINMAXINFO:
			rect.left = 0;
			rect.right = 54 * lCharWidth + GetSystemMetrics(SM_CXVSCROLL);
			rect.top = 0;
			rect.bottom = lCharHeight;
			if (bPopupSwnd) {
				AdjustWindowRect(&rect, WS_POPUP | WS_OVERLAPPED | WS_SYSMENU |
										WS_CAPTION | WS_VISIBLE | 
										WS_MINIMIZEBOX | WS_SIZEBOX, FALSE);
			}
			else {
				AdjustWindowRect(&rect, WS_CHILD | WS_OVERLAPPED | WS_SYSMENU |
										WS_CAPTION | WS_VISIBLE | 
										WS_MINIMIZEBOX | WS_CLIPSIBLINGS | 
										WS_SIZEBOX, FALSE);
			}
			((LPMINMAXINFO)lParam)->ptMinTrackSize.x = rect.right - rect.left;
			((LPMINMAXINFO)lParam)->ptMaxTrackSize.x = rect.right - rect.left;
			((LPMINMAXINFO)lParam)->ptMinTrackSize.y = rect.bottom - rect.top;
			return 0;

		/* ReLXgj[ */
		case WM_RBUTTONDOWN:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* ReLXgj[[h */
			hMenu = GetSubMenu(hDisAsm[nCPU], 0);
			CheckMenuSub(hMenu, IDM_DIS_SYNCPC, bSyncDisasm[nCPU]);
			EnableMenuSub(hMenu, IDM_DIS_SYNCPC, bSync);

			/* AhX[hݒ */
#if XM7_VER >= 2
			if ((nCPU == MAINCPU) && (fm7_ver >= 2)) {
#else
			if ((nCPU == MAINCPU) && (fm_subtype == FMSUB_FM77)) {
#endif
				CheckMenuSub(hMenu, IDM_DIS_PHYSADDR, bDisPhysicalAddr);
				EnableMenuSub(hMenu, IDM_DIS_PHYSADDR, TRUE);
			}
			else {
				CheckMenuSub(hMenu, IDM_DIS_PHYSADDR, FALSE);
				EnableMenuSub(hMenu, IDM_DIS_PHYSADDR, FALSE);
			}

			/* VXeX^bNWvj[ݒ */
			InsertStackJumpMenu(GetSubMenu(hMenu, 7), nCPU, IDM_DIS_STACK);

			/* u[N|Cgj[ݒ */
			InsertBreakPointMenu(GetSubMenu(hMenu, 8), nCPU, IDM_DIS_BREAK);

			/* ReLXgj[s */
			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			PosDisAsmPoint = point;
			ClientToScreen(hWnd, &point);
			TrackPopupMenu(hMenu, 0, point.x, point.y, 0, hWnd, NULL);
			return 0;

		/* NbNE_uNbN */
		case WM_LBUTTONDOWN:
		case WM_LBUTTONDBLCLK:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			LButtonDisAsm(hWnd, point, FALSE);
			break;

		/* R}h */
		case WM_COMMAND:
			CmdDisAsm(hWnd, LOWORD(wParam), nCPU);
			break;

		/* XN[o[ */
		case WM_VSCROLL:
			/* ^Cv */
			dwAddr = dwDisAsm[nCPU];

			/* ANV */
			switch (LOWORD(wParam)) {
				/* gbv */
				case SB_TOP:
					dwAddr = 0;
					break;
				/* I[ */
				case SB_BOTTOM:
					dwAddr = 0xffff;
					break;
				/* Ps */
				case SB_LINEUP:
					if (dwAddr > 0) {
						dwAddr--;
					}
					break;
				/* Ps(͍Hv) */
				case SB_LINEDOWN:
					ret = disline(nCPU, (WORD)dwAddr, string);
					i = (int)dwAddr;
					i += ret;
					if (i < 0x10000) {
						dwAddr += (WORD)ret;
					}
					break;
				/* y[WAbv */
				case SB_PAGEUP:
					if (dwAddr < 0x80) {
						dwAddr = 0;
					}
					else {
						dwAddr -= (WORD)0x80;
					}
					break;
				/* y[W_E */
				case SB_PAGEDOWN:
					if (dwAddr >= 0xff80) {
						dwAddr = 0xffff;
					}
					else {
						dwAddr += (WORD)0x80;
					}
					break;
				/* ڎw */
				case SB_THUMBTRACK:
					dwAddr = HIWORD(wParam);
					if (dwAddr >= 0xffff) {
						dwAddr = 0xffff;
					}
					break;
			}
			AddrDisAsm(nCPU, dwAddr);
			RefreshDisAsm();
			break;
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	tAZuEChE(C)
 *	EChEvV[W
 */
static LRESULT CALLBACK DisAsmProcMain(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return DisAsmProc(hWnd, message, wParam, lParam, MAINCPU);
}

/*
 *	tAZuEChE(Tu)
 *	EChEvV[W
 */
static LRESULT CALLBACK DisAsmProcSub(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return DisAsmProc(hWnd, message, wParam, lParam, SUBCPU);
}

#if ((XM7_VER == 1) && defined(JSUB))
/*
 *	tAZuEChE({Tu)
 *	EChEvV[W
 */
static LRESULT CALLBACK DisAsmProcJsub(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return DisAsmProc(hWnd, message, wParam, lParam, JSUBCPU);
}
#endif

/*
 *	tAZuEChE
 *	EChE쐬
 */
HWND FASTCALL CreateDisAsm(HWND hParent, BYTE nCPU, int index)
{
	WNDCLASSEX wcex;
	char szClassNameMain[] = "XM7_DisAsmMain";
	char szClassNameSub[] = "XM7_DisAsmSub";
#if ((XM7_VER == 1) && defined(JSUB))
	char szClassNameJsub[] = "XM7_DisAsmJsub";
#endif
	char *szClassName;
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	SCROLLINFO si;
	UINT id;
	WORD pc;
	DWORD dwStyle;

	ASSERT(hParent);

	/* EChE`vZ */
	PositioningSubWindow(hParent, &rect, index);
	rect.right = lCharWidth * 54;

	/* EChE^CgAobt@mہAj[h */
	switch (nCPU) {
		case MAINCPU :	id = IDS_SWND_DISASM_MAIN;
						pc = maincpu.pc;
						szClassName = szClassNameMain;
						break;
		case SUBCPU :	id = IDS_SWND_DISASM_SUB;
						pc = subcpu.pc;
						szClassName = szClassNameSub;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	id = IDS_SWND_DISASM_JSUB;
						pc = jsubcpu.pc;
						szClassName = szClassNameJsub;
						break;
#endif
	}
	rect.bottom = lCharHeight * nHeightDisAsm[nCPU];
	LoadString(hResInstance, id, szWndName, sizeof(szWndName));
	pDisAsm[nCPU] = malloc(2 * (rect.right / lCharWidth) * nHeightDisAsm[nCPU]);
	dwDisAsm[nCPU] = pc;
	hDisAsm[nCPU] = LoadMenu(hResInstance, MAKEINTRESOURCE(IDR_DISASMMENU));

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW;
	switch (nCPU) {
		case MAINCPU :	wcex.lpfnWndProc = DisAsmProcMain;
						break;
		case SUBCPU :	wcex.lpfnWndProc = DisAsmProcSub;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	wcex.lpfnWndProc = DisAsmProcJsub;
						break;
#endif
	}
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
	if (bPopupSwnd) {
		dwStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_VSCROLL | WS_SIZEBOX;
	}
	else {
		dwStyle =	WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS |
					WS_VSCROLL | WS_SIZEBOX;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);

		/* XN[o[̐ݒ肪Kv */
		memset(&si, 0, sizeof(si));
		si.cbSize = sizeof(si);
		si.fMask = SIF_ALL;
		si.nMin = 0;
		si.nMax = 0x100fe;
		si.nPage = 0x100;
		si.nPos = pc;
		SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
	}

	/* ʂA */
	return hWnd;
}

/*-[ eύX_CAO ]----------------------------------------------*/

/*
 *	eύX_CAO
 *	_CAO
 */
static BOOL FASTCALL MemoryChangeDlgInit(HWND hDlg)
{
	HWND hWnd;
	RECT prect;
	RECT drect;
	char tmp[16];
	char string[128];
	UINT id;

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* AhXݒ */
	hWnd = GetDlgItem(hDlg, IDC_MEMLABEL);
	ASSERT(hWnd);
	switch (nMemDlgCPU) {
		case MAINCPU :	if (isLinearAddrMode(bDumpPhysicalAddr)) {
							id = IDS_SWND_CPU_MAIN_P;
						}
						else {
							id = IDS_SWND_CPU_MAIN;
						}
						break;
		case SUBCPU :	id = IDS_SWND_CPU_SUB;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	id = IDS_SWND_CPU_JSUB;
						break;
#endif
	}
	LoadString(hResInstance, id, tmp, sizeof(tmp));
	if ((nMemDlgCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
		_snprintf(string, sizeof(string), "$%05X (%s)",
			dwMemDlgAddr & (GetMaxMemArea(bDumpPhysicalAddr) - 1), tmp);
	}
	else {
		_snprintf(string, sizeof(string), "$%04X (%s)",
			dwMemDlgAddr & 0xffff, tmp);
	}
	SetWindowText(hWnd, string);

	/* f[^ݒ */
	hWnd = GetDlgItem(hDlg, IDC_MEMEDIT);
	ASSERT(hWnd);
	_snprintf(string, sizeof(string), "%02X", nMemDlgByte);
	SetWindowText(hWnd, string);

	return TRUE;
}

/*
 *	eύX_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK MemoryChangeDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	HWND hWnd;
	char string[128];

	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return MemoryChangeDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						/* ݂̒l擾 */
						hWnd = GetDlgItem(hDlg, IDC_MEMEDIT);
						ASSERT(hWnd);
						GetWindowText(hWnd, string, sizeof(string) - 1);
						if (string[0] == 0x27) {
							nMemDlgByte = (BYTE)string[1];
						}
						else {
							nMemDlgByte = (BYTE)strtol(string, NULL, 16);
						}
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	eύX
 */
static BOOL FASTCALL MemoryChange(HWND hWnd, BYTE nCPU, int x, int y)
{
	BYTE (FASTCALL *readbnio)(WORD addr);
	void (FASTCALL *writeb)(WORD addr, BYTE dat);
	int height;
	int ret;

	ASSERT(hWnd);

	/* p[^ۑEݒ */
	switch (nCPU) {
		case MAINCPU :	readbnio = mainmem_readbnio;
						writeb = mainmem_writeb;
						break;
		case SUBCPU :	readbnio = submem_readbnio;
						writeb = submem_writeb;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	readbnio = jsubmem_readbnio;
						writeb = jsubmem_writeb;
						break;
#endif
	}
	ASSERT(readbnio);
	ASSERT(writeb);

	nMemDlgCPU = nCPU;
	height = nHeightMemory[nCPU];
	if (bAsciiDump[nCPU]) {
		height -= 3;
	}

	/* AhXZbg */
	if ((x < 7) || (x > 54) || (((x - 7) % 3) == 2) ||
		(y < 0) || (y >= height)) {
		/* W͈͊O */
		return FALSE;
	}

	/* AhXƌf[^擾 */
	if ((nMemDlgCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
		dwMemDlgAddr  = (DWORD)(dwMemory[nCPU] & 0xffff0);
		dwMemDlgAddr += (DWORD)((x - 7) / 3);
		dwMemDlgAddr += (DWORD)(y * 16);

		/* f[^Zbg */
		nMemDlgByte = mainmem_readbnio_p(dwMemDlgAddr);
	}
	else {
		dwMemDlgAddr  = (WORD)(dwMemory[nCPU] & 0xfff0);
		dwMemDlgAddr += (WORD)((x - 7) / 3);
		dwMemDlgAddr += (WORD)(y * 16);

		/* f[^Zbg */
		nMemDlgByte = readbnio((WORD)dwMemDlgAddr);
	}


	/* [__CAOs */
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_MEMDLG), hWnd, MemoryChangeDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}

	/* f[^Zbg */
	LockVM();
	if ((nMemDlgCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
		mainmem_writeb_p(dwMemDlgAddr, (BYTE)nMemDlgByte);
	}
	else {
		writeb((WORD)dwMemDlgAddr, (BYTE)nMemDlgByte);
	}
	InvalidateRect(hWnd, NULL, FALSE);
	UnlockVM();

	return TRUE;
}

/*-[ _CAO ]--------------------------------------------------*/

/*
 *	_CAO
 *	_CAO
 */
static BOOL FASTCALL MemorySearchDlgInit(HWND hDlg)
{
	HWND hWnd;
	RECT prect;
	RECT drect;
	char string[128];
	DWORD addr;

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_SEARCHADDR);
	ASSERT(hWnd);
	InsertHistory(hWnd, bDumpPhysicalAddr);

	/* AhXݒ */
	addr = dwMemSrchAddrSave[nMemSrchCPU];
	if ((nMemSrchCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
		_snprintf(string, sizeof(string), "%05X",
			addr & (GetMaxMemArea(bDumpPhysicalAddr) - 1));
	}
	else {
		_snprintf(string, sizeof(string), "%04X", addr & 0xffff);
	}
	ComboBox_SetText(hWnd, string);

	/* ݒ */
	hWnd = GetDlgItem(hDlg, IDC_SEARCHDATA);
	ASSERT(hWnd);
	SetWindowText(hWnd, (LPSTR)szMemSrchString);

	return TRUE;
}

/*
 *	_CAO
 *	_CAOOK
 */
static void FASTCALL MemorySearchDlgOK(HWND hDlg)
{
	HWND hWnd;
	char string[128];

	ASSERT(hDlg);

	/* ݂̒l擾 */
	hWnd = GetDlgItem(hDlg, IDC_SEARCHDATA);
	ASSERT(hWnd);
	GetWindowText(hWnd, szMemSrchString, sizeof(szMemSrchString) - 1);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_SEARCHADDR);
	ASSERT(hWnd);

	/* ݂̒l擾 */
	ComboBox_GetText(hWnd, string, sizeof(string) - 1);
	dwMemSrchAddr = (DWORD)strtol(string, NULL, 16);
	if ((nMemSrchCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
		dwMemSrchAddr &= (GetMaxMemArea(bDumpPhysicalAddr) - 1);
	}
	else {
		dwMemSrchAddr &= 0xffff;
	}

	/* qXgǉ */
	AddAddrHistory(dwMemSrchAddr, bDumpPhysicalAddr);
}

/*
 *	_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK MemorySearchDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return MemorySearchDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						MemorySearchDlgOK(hDlg);
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	
 */
static BOOL FASTCALL MemorySearch(HWND hWnd, BYTE nCPU)
{
	BYTE (FASTCALL *readbnio)(WORD addr);
	BYTE searchdata[128];
	char string[128];
	char tmp[128];
	char *p;
	char *q;
	BOOL flag;
	BYTE dat;
	DWORD datasize;
	DWORD i;
	DWORD j;
	int ret;

	ASSERT(hWnd);

	/* [__CAOs */
	nMemSrchCPU = nCPU;
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_SEARCHDLG), hWnd, MemorySearchDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}

	/* [Nݒ */
	switch (nCPU) {
		case MAINCPU :	readbnio = mainmem_readbnio;
						break;
		case SUBCPU :	readbnio = submem_readbnio;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	readbnio = jsubmem_readbnio;
						break;
#endif
	}
	dwMemSrchAddrSave[nCPU] = dwMemSrchAddr;
	memset(searchdata, 0, sizeof(searchdata));
	memset(string, 0, sizeof(string));
	memset(tmp, 0, sizeof(tmp));

	/* ϊ */
	if (szMemSrchString[0] == '#') {
		/* 16iƂċ镶̂ݔo */
		p = &szMemSrchString[1];
		q = string;
		while (*p != '\0') {
			if ((	((*p >= '0') && (*p <= '9')) ||
					((*p >= 'A') && (*p <= 'F')) ||
					((*p >= 'a') && (*p <= 'f')))) {
				*q++ = *p;
			}
			p++;
		}

		/* f[^֕ϊ */
		datasize = 0;
		p = string;

		while (*p != '\0') {
			memcpy(tmp, p, 2);
			searchdata[datasize ++] = (BYTE)strtol(tmp, NULL, 16);
			p += 2;
		}
	}
	else {
		/* w */
		datasize = strlen(szMemSrchString);
		memcpy(searchdata, szMemSrchString, datasize);
	}

	/* f[^ȂꍇȂ */
	if (datasize == 0) {
		return FALSE;
	}

	/* f[^ */
	flag = FALSE;
	if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
		for (i=dwMemSrchAddr; i<GetMaxMemArea(bDumpPhysicalAddr) - datasize; i++) {
			dat = mainmem_readbnio_p(i);

			/* 擪f[^vꍇɎc̃f[^`FbN*/
			if (searchdata[0] == dat) {
				for (j=1; j<datasize; j++) {
					if (searchdata[j] != mainmem_readbnio_p(i + j)) {
						break;
					}
				}
				if (j == datasize) {
					/*  */
					LoadString(hResInstance, IDS_SWND_SRCH_FOUND_P, tmp, sizeof(tmp));
					_snprintf(string, sizeof(string), tmp, i);
					flag = TRUE;
					break;
				}
			}
		}
	}
	else {
		for (i=(WORD)dwMemSrchAddr; i<65536 - datasize; i++) {
			dat = readbnio((WORD)i);

			/* 擪f[^vꍇɎc̃f[^`FbN*/
			if (searchdata[0] == dat) {
				for (j=1; j<datasize; j++) {
					if (searchdata[j] != readbnio((WORD)(i + j))) {
						break;
					}
				}
				if (j == datasize) {
					/*  */
					LoadString(hResInstance, IDS_SWND_SRCH_FOUND, tmp, sizeof(tmp));
					_snprintf(string, sizeof(string), tmp, i);
					flag = TRUE;
					break;
				}
			}
		}
	}

	if (!flag) {
		/* ł */
		LoadString(hResInstance, IDS_SWND_SRCH_NOTFOUND, string, sizeof(string));
	}

	/* ʂ\ */
	MessageBox(hMainWnd, string, "XM7", MB_OK | MB_ICONINFORMATION);
	SetMenuExitTimer();

	if (flag) {
		/* łꍇ͂̃AhXɔ΂ */
		AddrMemory(nCPU, i);

		/* JnAhXXV */
		if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
			dwMemSrchAddrSave[nCPU] = (DWORD)(i + datasize);
		}
		else {
			dwMemSrchAddrSave[nCPU] = (WORD)(i + datasize);
		}
	}

	return TRUE;
}

/*-[ _vEChE ]------------------------------------------------*/

/*-[ _vEChE ]------------------------------------------------*/

/*
 *	_vEChE
 *	AhXݒ
 */
void FASTCALL AddrMemory(BYTE nCPU, DWORD dwAddr)
{
	SCROLLINFO sif;
	int height;

	/* AhXړ͈͂𐧌 */
	if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
		dwAddr &= (DWORD)(GetMaxMemArea(bDumpPhysicalAddr) - 1);
	}
	else {
		dwAddr &= (DWORD)(0xfff0);
	}
	height = nHeightMemory[nCPU];
	if (bAsciiDump[nCPU]) {
		height -= 3;
	}
	if (dwAddr >= ((GetMaxMemArea(bDumpPhysicalAddr) + 0x0f) - height * 16)) {
		dwAddr = GetMaxMemArea(bDumpPhysicalAddr) - (height * 16);
	}

	memset(&sif, 0, sizeof(sif));
	sif.cbSize = sizeof(sif);
	sif.fMask = SIF_POS;
	sif.nPos = (int)(dwAddr >> 4);

	/* ݃`FbNݒ */
	dwMemory[nCPU] = dwAddr;
	switch (nCPU) {
		case MAINCPU :	if (hSubWnd[SWND_MEMORY_MAIN]) {
							SetScrollInfo(hSubWnd[SWND_MEMORY_MAIN], SB_VERT,
								&sif, TRUE);
						}
						break;
		case SUBCPU :	if (hSubWnd[SWND_MEMORY_SUB]) {
							SetScrollInfo(hSubWnd[SWND_MEMORY_SUB], SB_VERT,
								&sif, TRUE);
						}
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	if (hSubWnd[SWND_MEMORY_JSUB]) {
							SetScrollInfo(hSubWnd[SWND_MEMORY_JSUB], SB_VERT,
								&sif, TRUE);
						}
						break;
#endif
	}

	/* tbV */
	RefreshMemory();
}

/*
 *	_vEBhE
 *	TCY
 */
static void FASTCALL ResizeMemory(HWND hWnd, WORD cx, WORD cy, BYTE nCPU)
{
	RECT crect;
	RECT wrect;
	SCROLLINFO si;
	BYTE *p;
	int width;
	int height;

	ASSERT(hWnd);

	/* ŏ̏ꍇ́AȂ */
	if ((cx == 0) && (cy == 0)) {
		return;
	}

	/* cTCYύX */
	nHeightMemory[nCPU] = (WORD)(cy / lCharHeight);
	if (nHeightMemory[nCPU] < 1) {
		nHeightMemory[nCPU] = 1;
	}

	/* TCYύX */
	if (bAsciiDump[nCPU]) {
		width = 76;
	}
	else {
		width = 54;
	}

	/* EBhE`ύX */
	GetWindowRect(hWnd, &wrect);
	GetClientRect(hWnd, &crect);
	wrect.right -= wrect.left;
	wrect.right -= crect.right;
	wrect.right += (width * lCharWidth);
	wrect.bottom -= wrect.top;
	wrect.bottom -= crect.bottom;
	wrect.bottom += (nHeightMemory[nCPU] * lCharHeight);
	SetWindowPos(hWnd, HWND_TOP, 0, 0, wrect.right, wrect.bottom,
							SWP_NOZORDER | SWP_NOMOVE);

	/* obt@Ď擾A0xFFŖ߂ */
	p = realloc(pMemory[nCPU], 2 * width * nHeightMemory[nCPU]);
	ASSERT(p);
	pMemory[nCPU] = p;
	memset(p, 0xff, 2 * width * nHeightMemory[nCPU]);

	/* XN[o[̐ݒ */
	memset(&si, 0, sizeof(si));
	height = nHeightMemory[nCPU];
	if (bAsciiDump[nCPU]) {
		height -= 3;
	}
	si.cbSize = sizeof(si);
	si.fMask = SIF_ALL;
	si.nMin = 0;
	si.nMax = ((GetMaxMemArea(bDumpPhysicalAddr) >> 4) | 0x0f) - height;
	si.nPage = 0x10;
	si.nPos = (dwMemory[nCPU] >> 4);
	if (si.nPos > si.nMax) {
		si.nPos = si.nMax;
	}
	SetScrollInfo(hWnd, SB_VERT, &si, TRUE);

	if (bPopupSwnd) {
		SetForegroundWindow(hMainWnd);
	}
}

/*
 *	_vEBhE
 *	TCY(sw)
 */
static void FASTCALL ResizeMemoryLines(HWND hWnd, int lines, BYTE nCPU)
{
	RECT rect;

	GetWindowRect(hWnd, &rect);
	ResizeMemory(hWnd, 	(WORD)(rect.right - rect.left + 1), 
						(WORD)(lCharHeight * lines), nCPU);
}

/*
 *	_vEChE
 *	ZbgAbv
 */
static void FASTCALL SetupMemory(BYTE nCPU, BYTE *p, int x, int y)
{
	BYTE (FASTCALL *readbnio)(WORD addr);
	char string[128];
	char temp[32];
	DWORD addr;
	int i;
	int j;
	int height;
	BYTE mem[16];
	BYTE tsum[16];
	BYTE sum;
	BYTE knjsave;
	int offset;
	BOOL isj;

	ASSERT(nCPU < MAXCPU);
	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);
	memset(tsum, 0, 16);

	/* [N */
	knjsave = 0;
	isj = isJapanese;

	/* AhX擾 */
	if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
		addr = (DWORD)(dwMemory[nCPU] & 0xffff0);
	}
	else {
		addr = (WORD)(dwMemory[nCPU] & 0xfff0);
	}
	height = nHeightMemory[nCPU];
	switch (nCPU) {
		case MAINCPU :	readbnio = mainmem_readbnio;
						break;
		case SUBCPU :	readbnio = submem_readbnio;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	readbnio = jsubmem_readbnio;
						break;
#endif
	}

	/* ASCII_v[h 㕔KCh */
	if (bAsciiDump[nCPU]) {
		strncpy(string, "Addr  ", sizeof(string));
		for (j=0; j<16; j++) {
			_snprintf(temp, sizeof(temp), " +%01X", j);
			strncat(string, temp, sizeof(string) - strlen(string) - 1);
		}
		strncat(string, " Sum", sizeof(string) - strlen(string) - 1);

		/* Rs[ */
		memcpy(p, string, strlen(string));

		offset = 1;
		height -= 3;
	}
	else {
		offset = 0;
	}

	/* [v */
	for (i=0; i<height; i++) {
		/* 쐬 */
		if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
			_snprintf(string, sizeof(string), "%05X:", addr);
		}
		else {
			_snprintf(string, sizeof(string), "%04X :", (WORD)(addr & 0xffff));
		}
		sum = 0;
		for (j=0; j<16; j++) {
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				mem[j] = mainmem_readbnio_p((DWORD)(addr + j));
			}
			else {
				mem[j] = readbnio((WORD)(addr + j));
			}
			_snprintf(temp, sizeof(temp), " %02X", mem[j]);
			tsum[j] += mem[j];
			sum += mem[j];
			strncat(string, temp, sizeof(string) - strlen(string) - 1);
		}

		if (bAsciiDump[nCPU]) {
			/* `FbNTEKCh */
			_snprintf(temp, sizeof(temp), " :%02X  ................", sum);
			strncat(string, temp, sizeof(string) - strlen(string) - 1);

			/* R[h2sɂ܂ꍇ̏ */
			if (isj && isKanji(knjsave)) {
				string[59] = knjsave;
				knjsave = 1;
			}

			/* ASCII_v */
			for (j=0; j<16; j++) {
				if ((mem[j] < 0x20) || (mem[j] == 0x7f) || (mem[j] >= 0xfd)) {
					/* Rg[R[h(\) */
					knjsave = 0;
				}
				else if (!isj && (mem[j] & 0x80)) {
					/* {ꃂ[h 0x80`0xFF(\) */
					knjsave = 0;
				}
				else if (bKanjiDump[nCPU] && isKanji(mem[j]) && (knjsave == 0)) {
					/*  */

					if (j == 15) {
						/* sɂ܂ꍇ͔\ */
						string[j + 60] = ' ';
						knjsave = mem[j];
					}
					else {
						if (isKanji2(mem[j + 1])) {
							/* 2oCgƂȂꍇ */
							string[j + 60] = mem[j];
							knjsave = 1;
						}
						else {
							/* R[hُ(\) */
							knjsave = 0;
						}
					}
				}
				else {
					if ((mem[j] == 0xa0) && (knjsave == 0)) {
						/* f[^$A0ŃVtgJIS2oCgłȂꍇ */
						string[j + 60] = ' ';
					}
					else if ((!isKanji(mem[j]) && (mem[j] != 0x80)) || (knjsave == 1)) {
						/* ANK ܂ VtgJIS2oCg */
						string[j + 60] = mem[j];
					}
					knjsave = 0;
				}
			}
		}

		/* Rs[ */
		memcpy(&p[x * (i + offset)], string, strlen(string));

		/*  */
		addr = (DWORD)(addr + 0x0010) & (GetMaxMemArea(bDumpPhysicalAddr) - 1);
		if (addr == 0) {
			break;
		}
	}

	/* ASCII_v[h rEcTEubNT */
	if (bAsciiDump[nCPU]) {
		/* r쐬 */
		memset(string, '-', 76);
		memset(&string[58], ' ', 2);
		string[77] = '\0';

		/* Rs[ */
		memcpy(&p[x * (height + 1)], string, strlen(string));

		/* cT쐬 */
		_snprintf(string, sizeof(string), "Sum  :", addr);
		sum = 0;
		for (j=0; j<16; j++) {
			_snprintf(temp, sizeof(temp), " %02X", tsum[j]);
			sum += tsum[j];
			strncat(string, temp, sizeof(string) - strlen(string) - 1);
		}

		/* `FbNT */
		_snprintf(temp, sizeof(temp), " :%02X", sum);
		strncat(string, temp, sizeof(string) - strlen(string) - 1);

		/* Rs[ */
		memcpy(&p[x * (height + 2)], string, strlen(string));
	}
}

/*
 *	_vEChE
 *	`
 */
static void FASTCALL DrawMemory(HWND hWnd, HDC hDC)
{
	int i;
	BYTE nCPU;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			nCPU = (BYTE)((i - SWND_CPUREG_MAIN) % MAXCPU);
			p = pMemory[nCPU];
			break;
		}
	}
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	SetupMemory(nCPU, p, x, y);

	/* ` */
	if (bKanjiDump[nCPU] && isJapanese) {
		DrawWindowTextKanji(hDC, p, x, y);
	}
	else {
		DrawWindowText(hDC, p, x, y);
	}
}

/*
 *	_vEChE
 *	tbV
 */
void FASTCALL RefreshMemory(void)
{
	HWND hWnd;
	HDC hDC;
	DWORD dwAddr;
	int height;

	/* CCPU */
	if (hSubWnd[SWND_MEMORY_MAIN]) {
		hWnd = hSubWnd[SWND_MEMORY_MAIN];
#if XM7_VER >= 3
		if ((bExtendMMRMode != mmr_ext) || (nFM7Ver != fm7_ver)) {
#elif XM7_VER == 2
		if (nFM7Ver != fm7_ver) {
#else
		if (nFMsubtype != fm_subtype) {
#endif
#if XM7_VER >= 2
			nFM7Ver = fm7_ver;
#if XM7_VER >= 3
			bExtendMMRMode = mmr_ext;
#endif
#else
			nFMsubtype = fm_subtype;
#endif
			if (bDumpPhysicalAddr) {
#if XM7_VER >= 2
				if (fm7_ver == 1) {
#else
				if (fm_subtype != FMSUB_FM77) {
#endif
					dwMemory[MAINCPU] = mmr_trans_phys_to_logi(
						dwMemory[MAINCPU]);
				}
				else {
					dwMemory[MAINCPU] = mmr_trans_mmr(
						(WORD)(dwMemory[MAINCPU] & 0xffff));
				}
			}
			height = nHeightMemory[MAINCPU];
			if (bAsciiDump[MAINCPU]) {
				height -= 3;
			}
			ResizeMemoryLines(hWnd, nHeightMemory[MAINCPU], MAINCPU);
			dwAddr = GetMaxMemArea(bDumpPhysicalAddr) - (height * 0x10);
			if (dwMemory[MAINCPU] >= dwAddr) {
				dwMemory[MAINCPU] = dwAddr;
			}
			AddrMemory(MAINCPU, dwMemory[MAINCPU]);
			PaintMemory(hWnd);
		}
		else {
			hDC = GetDC(hWnd);
			DrawMemory(hWnd, hDC);
			ReleaseDC(hWnd, hDC);
		}
	}

	/* TuCPU */
	if (hSubWnd[SWND_MEMORY_SUB]) {
		hWnd = hSubWnd[SWND_MEMORY_SUB];
		hDC = GetDC(hWnd);
		DrawMemory(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

#if ((XM7_VER == 1) && defined(JSUB))
	/* {TuCPU */
	if (hSubWnd[SWND_MEMORY_JSUB]) {
		hWnd = hSubWnd[SWND_MEMORY_JSUB];
		hDC = GetDC(hWnd);
		DrawMemory(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}
#endif
}

/*
 *	_vEChE
 *	ĕ`
 */
static void FASTCALL PaintMemory(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	int i;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			p = pMemory[((i - SWND_CPUREG_MAIN) % MAXCPU)];
			break;
		}
	}

	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawMemory(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	_vEChE
 *	R}h
 */
static void FASTCALL CmdMemory(HWND hWnd, WORD wID, BYTE nCPU)
{
	DWORD target;
	cpu6809_t *cpu;
	BYTE height;

	/* CPU\̌ */
	switch (nCPU) {
		case MAINCPU :	cpu = &maincpu;
						break;
		case SUBCPU :	cpu = &subcpu;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	cpu = &jsubcpu;
						break;
#endif
	}

	/* ^[QbgAhX */
	switch (wID) {
		case IDM_DMP_ADDR:
			target = dwMemory[nCPU];
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				if (!AddrDlg(hWnd, &target, nCPU, TRUE)) {
					return;
				}
			}
			else {
				if (!AddrDlg(hWnd, &target, nCPU, FALSE)) {
					return;
				}
			}
			target &= GetMaxMemArea(bDumpPhysicalAddr) - 1;
			break;

		case IDM_DMP_BLK128:
		case IDM_DMP_BLK256:
			if (wID == IDM_DMP_BLK128) {
				height = 8;
			}
			else if (wID == IDM_DMP_BLK256) {
				height = 16;
			}
			if (bAsciiDump[nCPU]) {
				height += (BYTE)3;
			}
			ResizeMemoryLines(hWnd, height, nCPU);
			return;

		case IDM_DMP_ASCII:
			bAsciiDump[nCPU] = !bAsciiDump[nCPU];

			/* cTCYύX */
			height = nHeightMemory[nCPU];
			if (bAsciiDump[nCPU]) {
				height += (BYTE)3;
			}
			else {
				height -= (BYTE)3;
			}
			ResizeMemoryLines(hWnd, height, nCPU);
			PaintMemory(hWnd);
			return;

		case IDM_DMP_KANJI:
			bKanjiDump[nCPU] = !bKanjiDump[nCPU];
			InvalidateRect(hWnd, NULL, FALSE);
			return;

		case IDM_DMP_SEARCH:
			MemorySearch(hWnd, nCPU);
			return;

		case IDM_DMP_PHYSADDR:
#if XM7_VER == 1
			if ((fm_subtype != FMSUB_FM77) || nCPU != MAINCPU) {
#else
			if ((fm7_ver <= 1) || nCPU != MAINCPU) {
#endif
				break;
			}

			if (bDumpPhysicalAddr) {
				target = mmr_trans_phys_to_logi(dwMemory[nCPU]);
			}
			else {
				target = mmr_trans_mmr((WORD)(dwMemory[nCPU] & 0xffff));
			}
			bDumpPhysicalAddr = !bDumpPhysicalAddr;
			ResizeMemoryLines(hWnd, nHeightMemory[nCPU], nCPU);
			break;

		case IDM_DMP_PC:
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = mmr_trans_mmr(cpu->pc);
			}
			else {
				target = (DWORD)cpu->pc;
			}
			break;
		case IDM_DMP_X:
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = mmr_trans_mmr(cpu->x);
			}
			else {
				target = (DWORD)cpu->x;
			}
			break;
		case IDM_DMP_Y:
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = mmr_trans_mmr(cpu->y);
			}
			else {
				target = (DWORD)cpu->y;
			}
			break;
		case IDM_DMP_U:
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = mmr_trans_mmr(cpu->u);
			}
			else {
				target = (DWORD)cpu->u;
			}
			break;
		case IDM_DMP_S:
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = mmr_trans_mmr(cpu->s);
			}
			else {
				target = (DWORD)cpu->s;
			}
			break;
		case IDM_DMP_DP:
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = mmr_trans_mmr((WORD)(cpu->dp << 8));
			}
			else {
				target = (DWORD)(cpu->dp << 8);
			}
			break;

		case IDM_DMP_RESET:
			target = (WORD)((cpu->readmem(0xfffe) << 8) | cpu->readmem(0xffff));
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = (DWORD)mmr_trans_mmr((WORD)target);
			}
			break;
		case IDM_DMP_NMI:
			target = (WORD)((cpu->readmem(0xfffc) << 8) | cpu->readmem(0xfffd));
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = (DWORD)mmr_trans_mmr((WORD)target);
			}
			break;
		case IDM_DMP_SWI:
			target = (WORD)((cpu->readmem(0xfffa) << 8) | cpu->readmem(0xfffb));
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = (DWORD)mmr_trans_mmr((WORD)target);
			}
			break;
		case IDM_DMP_IRQ:
			target = (WORD)((cpu->readmem(0xfff8) << 8) | cpu->readmem(0xfff9));
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = (DWORD)mmr_trans_mmr((WORD)target);
			}
			break;
		case IDM_DMP_FIRQ:
			target = (WORD)((cpu->readmem(0xfff6) << 8) | cpu->readmem(0xfff7));
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = (DWORD)mmr_trans_mmr((WORD)target);
			}
			break;
		case IDM_DMP_SWI2:
			target = (WORD)((cpu->readmem(0xfff4) << 8) | cpu->readmem(0xfff5));
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = (DWORD)mmr_trans_mmr((WORD)target);
			}
			break;
		case IDM_DMP_SWI3:
			target = (WORD)((cpu->readmem(0xfff2) << 8) | cpu->readmem(0xfff3));
			if ((nCPU == MAINCPU) && isLinearAddrMode(bDumpPhysicalAddr)) {
				target = (DWORD)mmr_trans_mmr((WORD)target);
			}
			break;
		case IDM_DMP_IO:
			switch (nCPU) {
				case MAINCPU :	if (bDumpPhysicalAddr) {
									bDumpPhysicalAddr = FALSE;
									ResizeMemoryLines(hWnd,
										nHeightMemory[nCPU], nCPU);
								}
								target = 0xfd00;
								break;
				case SUBCPU :	target = 0xd400;
								break;
				default :		target = 0x0000;
			}
			break;
		default:
			if ((wID >= IDM_DMP_STACK) && (wID <= IDM_DMP_STACK + 15)) {
				target = mmr_trans_mmr((WORD)wStackAddr[wID - IDM_DMP_STACK]);
			}
			if ((wID >= IDM_DMP_00000) && (wID <= IDM_DMP_F0000)) {
				target = (wID - IDM_DMP_00000) * 0x10000;
			}
			break;
	}

	/* ݒ聕XV */
	AddrMemory(nCPU, target);
}

/*
 *	_vEChE
 *	EChEvV[W
 */
static LRESULT CALLBACK MemoryProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam, BYTE nCPU)
{
	static BOOL bResize = FALSE;		/* 蓮TCYtO */
	HMENU hMenu;
	POINT point;
	DWORD dwAddr;
	int height;
	UINT idcheck;
	RECT rect;

	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintMemory(hWnd);
			UnlockVM();
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pMemory[nCPU], hMemory[nCPU]);

			UnlockVM();
			break;

		/* EChETCYύX */
		case WM_SIZE:
			if (bResize) {
				bResize = FALSE;
				ResizeMemory(hWnd, LOWORD(lParam), HIWORD(lParam), nCPU);
				height = nHeightMemory[nCPU];
				if (bAsciiDump[nCPU]) {
					height -= 3;
				}
				if (nCPU == MAINCPU) {
					dwAddr = GetMaxMemArea(bDumpPhysicalAddr) - (height * 0x10);
				}
				else {
					dwAddr = 0x10000 - (height * 0x10);
				}
				if (dwMemory[nCPU] >= dwAddr) {
					AddrMemory(nCPU, dwAddr);
					PaintMemory(hWnd);
				}
			}
			break;

		/* EChETCYύX */
		case WM_SIZING:
			WindowSizing(hWnd, (LPRECT)lParam, &pMemory[nCPU]);
			bResize = TRUE;
			break;

		/* EBhETCYύXbZ[W */
		case WM_WINDOWPOSCHANGING:
			bResize = TRUE;
			break;

		/* ŏTCY */
		case WM_GETMINMAXINFO:
			rect.left = 0;
			rect.right = 54 * lCharWidth + GetSystemMetrics(SM_CXVSCROLL);
			rect.top = 0;
			rect.bottom = lCharHeight;

			/* ASCII_v[h̏cTXy[Xl */
			if (bAsciiDump[nCPU]) {
				rect.right += (22 * lCharWidth);
				rect.bottom += (lCharHeight * 3);
			}

			if (bPopupSwnd) {
				AdjustWindowRect(&rect, WS_POPUP | WS_OVERLAPPED | WS_SYSMENU |
										WS_CAPTION | WS_VISIBLE | 
										WS_MINIMIZEBOX | WS_SIZEBOX, FALSE);
			}
			else {
				AdjustWindowRect(&rect, WS_CHILD | WS_OVERLAPPED | WS_SYSMENU |
										WS_CAPTION | WS_VISIBLE | 
										WS_MINIMIZEBOX | WS_CLIPSIBLINGS | 
										WS_SIZEBOX, FALSE);
			}
			((LPMINMAXINFO)lParam)->ptMinTrackSize.x = rect.right - rect.left;
			((LPMINMAXINFO)lParam)->ptMaxTrackSize.x = rect.right - rect.left;
			((LPMINMAXINFO)lParam)->ptMinTrackSize.y = rect.bottom - rect.top;
			return 0;

		/* eύX */
		case WM_LBUTTONDBLCLK:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* J[\ʒuA */
			point.x = LOWORD(lParam) / lCharWidth;
			point.y = HIWORD(lParam) / lCharHeight;
			if (bAsciiDump[nCPU]) {
				point.y --;
			}

			MemoryChange(hWnd, nCPU, point.x, point.y);
			return 0;

		/* ReLXgj[ */
		case WM_CONTEXTMENU:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* Tuj[o */
			hMenu = GetSubMenu(hMemory[nCPU], 0);
			height = nHeightMemory[nCPU];
			if (bAsciiDump[nCPU]) {
				height -= 3;
			}

			/* \TCY`FbN */
			CheckMenuSub(hMenu, IDM_DMP_BLK128, FALSE);
			CheckMenuSub(hMenu, IDM_DMP_BLK256, FALSE);
			if (height == 8) {
				idcheck = IDM_DMP_BLK128;
			}
			else if (height == 16) {
				idcheck = IDM_DMP_BLK256;
			}
			else {
				idcheck = 0;
			}
			if (idcheck > 0) {
				CheckMenuRadioItem(hMenu, IDM_DMP_BLK128, IDM_DMP_BLK256, idcheck, MF_BYCOMMAND);
			}

			/* ASCII_v`FbN */
			CheckMenuSub(hMenu, IDM_DMP_ASCII, bAsciiDump[nCPU]);

			/* \`FbN */
			if (isJapanese) {
				EnableMenuSub(hMenu, IDM_DMP_KANJI, bAsciiDump[nCPU]);
				CheckMenuSub(hMenu, IDM_DMP_KANJI, bKanjiDump[nCPU]);
			}
			else {
				EnableMenuSub(hMenu, IDM_DMP_KANJI, FALSE);
				CheckMenuSub(hMenu, IDM_DMP_KANJI, FALSE);
			}

#if ((XM7_VER == 1) && defined(JSUB))
			/* I/Ö`FbN */
			if (nCPU == JSUBCPU) {
				EnableMenuSub(hMenu, IDM_DMP_IO, FALSE);
			}
			else {
				EnableMenuSub(hMenu, IDM_DMP_IO, TRUE);
			}
#endif

			/* AhX */
#if XM7_VER == 1
			if ((fm_subtype == FMSUB_FM77) && (nCPU == MAINCPU)) {
#else
			if ((fm7_ver >= 2) && (nCPU == MAINCPU)) {
#endif
				EnableMenuSub(hMenu, IDM_DMP_PHYSADDR, TRUE);
				CheckMenuSub(hMenu, IDM_DMP_PHYSADDR, bDumpPhysicalAddr);
				if (bDumpPhysicalAddr) {
					EnableMenuItem(hMenu, 9, MF_BYPOSITION | MF_ENABLED);
				}
				else {
					EnableMenuItem(hMenu, 9, MF_BYPOSITION | MF_GRAYED);
				}
			}
			else {
				EnableMenuSub(hMenu, IDM_DMP_PHYSADDR, FALSE);
				CheckMenuSub(hMenu, IDM_DMP_PHYSADDR, FALSE);
				EnableMenuItem(hMenu, 9, MF_BYPOSITION | MF_GRAYED);
			}
			InsertPhysicalMemMenu(GetSubMenu(hMenu, 9), nCPU, IDM_DMP_00000);

			/* VXeX^bNWvj[ݒ */
			InsertStackJumpMenu(GetSubMenu(hMenu, 13), nCPU, IDM_DMP_STACK);

			/* ReLXgj[s */
			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			TrackPopupMenu(hMenu, 0, point.x, point.y, 0, hWnd, NULL);
			return 0;

		/* R}h */
		case WM_COMMAND:
			CmdMemory(hWnd, LOWORD(wParam), nCPU);
			break;

		/* XN[o[ */
		case WM_VSCROLL:
			/* ^Cv */
			dwAddr = dwMemory[nCPU];
			height = nHeightMemory[nCPU];
			if (bAsciiDump[nCPU]) {
				height -= 3;
			}

			/* ANV */
			switch (LOWORD(wParam)) {
				/* gbv */
				case SB_TOP:
					dwAddr = 0;
					break;
				/* I[ */
				case SB_BOTTOM:
					if (nCPU == MAINCPU) {
						dwAddr = (DWORD)(GetMaxMemArea(bDumpPhysicalAddr) - height * 16);
					}
					else {
						dwAddr = (DWORD)(0x10000 - height * 16);
					}
					break;
				/* Ps */
				case SB_LINEUP:
					if (dwAddr >= 0x0010) {
						dwAddr -= (WORD)0x0010;
					}
					break;
				/* Ps */
				case SB_LINEDOWN:
					if (nCPU == MAINCPU) {
						if (dwAddr < GetMaxMemArea(bDumpPhysicalAddr) - (DWORD)(height * 16)) {
							dwAddr += (DWORD)0x0010;
						}
					}
					else {
						if (dwAddr < 0x10000 - (DWORD)(height * 16)) {
							dwAddr += (DWORD)0x0010;
						}
					}
					break;
				/* y[WAbv */
				case SB_PAGEUP:
					if (dwAddr <= (DWORD)(height * 16)) {
						dwAddr = 0;
					}
					else {
						dwAddr -= (DWORD)(height * 0x10);
						if (nCPU == MAINCPU) {
							dwAddr &= (GetMaxMemArea(bDumpPhysicalAddr) - 1);
						}
						else {
							dwAddr &= 0xffff;
						}
					}
					break;
				/* y[W_E */
				case SB_PAGEDOWN:
					if (nCPU == MAINCPU) {
						if (dwAddr >= (GetMaxMemArea(bDumpPhysicalAddr) - (height * 16))) {
							dwAddr = GetMaxMemArea(bDumpPhysicalAddr) - (height * 16);
						}
						else {
							dwAddr += (DWORD)(height * 16);
							dwAddr &= (GetMaxMemArea(bDumpPhysicalAddr) - 1);
						}
					}
					else {
						if (dwAddr >= (0x10000 - (DWORD)(height * 16))) {
							dwAddr = (0x10000 - (DWORD)(height * 16));
						}
						else {
							dwAddr += (DWORD)(height * 16);
							dwAddr &= 0xffff;
						}
					}
					break;
				/* ڎw */
				case SB_THUMBTRACK:
					if (nCPU == MAINCPU) {
						dwAddr = (DWORD)(HIWORD(wParam) * 16) &
							(GetMaxMemArea(bDumpPhysicalAddr) - 1);
						if (dwAddr >= ((GetMaxMemArea(bDumpPhysicalAddr) + 0x0f) -
							(DWORD)(height * 16))) {
							dwAddr = GetMaxMemArea(bDumpPhysicalAddr) - (DWORD)(height * 16);
						}
					}
					else {
						dwAddr = (DWORD)(HIWORD(wParam) * 16) & 0xffff;
						if (dwAddr >= (0x1000f - (DWORD)(height * 16))) {
							dwAddr = 0x10000 - (DWORD)(height * 16);
						}
					}
					break;
			}
			dwAddr &= (GetMaxMemArea(bDumpPhysicalAddr) - 0x10);
			AddrMemory(nCPU, dwAddr);
			RefreshMemory();
			break;
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	_vEChE(C)
 *	EChEvV[W
 */
static LRESULT CALLBACK MemoryProcMain(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return MemoryProc(hWnd, message, wParam, lParam, MAINCPU);
}

/*
 *	_vEChE(Tu)
 *	EChEvV[W
 */
static LRESULT CALLBACK MemoryProcSub(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return MemoryProc(hWnd, message, wParam, lParam, SUBCPU);
}

/*
 *	_vEChE({Tu)
 *	EChEvV[W
 */
#if ((XM7_VER == 1) && defined(JSUB))
static LRESULT CALLBACK MemoryProcJsub(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return MemoryProc(hWnd, message, wParam, lParam, JSUBCPU);
}
#endif

/*
 *	_vEChE
 *	EChE쐬
 */
HWND FASTCALL CreateMemory(HWND hParent, BYTE nCPU, int index)
{
	WNDCLASSEX wcex;
	char szClassNameMain[] = "XM7_MemoryMain";
	char szClassNameSub[] = "XM7_MemorySub";
#if ((XM7_VER == 1) && defined(JSUB))
	char szClassNameJsub[] = "XM7_MemoryJsub";
#endif
	char *szClassName;
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	int height;
	SCROLLINFO si;
	UINT id;
	DWORD pc;
	DWORD dwStyle;

	ASSERT(hParent);

	/* MMRg[hA@o[W/Tuo[W̏lݒ */
#if XM7_VER >= 2
	nFM7Ver = fm7_ver;
#if XM7_VER >= 3
	bExtendMMRMode = mmr_ext;
#endif
#else
	nFMsubtype = fm_subtype;
#endif

	/* EChE`vZ */
	PositioningSubWindow(hParent, &rect, index);

	/* EChE^CgAobt@mہAj[[h */
	switch (nCPU) {
		case MAINCPU :	id = IDS_SWND_MEMORY_MAIN;
						if (bDumpPhysicalAddr) {
							pc = maincpu.pc;
							if (!mmr_trans_twr(maincpu.pc, &pc)) {
								pc = mmr_trans_mmr(maincpu.pc);
							}
						}
						else {
							pc = maincpu.pc;
						}
						szClassName = szClassNameMain;
						break;
		case SUBCPU :	id = IDS_SWND_MEMORY_SUB;
						pc = subcpu.pc;
						szClassName = szClassNameSub;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	id = IDS_SWND_MEMORY_JSUB;
						pc = jsubcpu.pc;
						szClassName = szClassNameJsub;
						break;
#endif
	}
	rect.bottom = lCharHeight * nHeightMemory[nCPU];
	LoadString(hResInstance, id, szWndName, sizeof(szWndName));
	pMemory[nCPU] = malloc(2 * 77 * nHeightMemory[nCPU]);
	dwMemory[nCPU] = pc;
	hMemory[nCPU] = LoadMenu(hResInstance, MAKEINTRESOURCE(IDR_MEMDMPMENU));

	/* EBhE */
	if (bAsciiDump[nCPU]) {
		rect.right = lCharWidth * 76;
	}
	else {
		rect.right = lCharWidth * 54;
	}

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS;
	switch (nCPU) {
		case MAINCPU :	wcex.lpfnWndProc = MemoryProcMain;
						break;
		case SUBCPU :	wcex.lpfnWndProc = MemoryProcSub;
						break;
#if ((XM7_VER == 1) && defined(JSUB))
		case JSUBCPU :	wcex.lpfnWndProc = MemoryProcJsub;
						break;
#endif
	}
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
	if (bPopupSwnd) {
		dwStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_VSCROLL | WS_SIZEBOX;
	}
	else {
		dwStyle =	WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
					WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS |
					WS_VSCROLL | WS_SIZEBOX;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);

		/* XN[o[̐ݒ肪Kv */
		memset(&si, 0, sizeof(si));
		si.cbSize = sizeof(si);
		si.fMask = SIF_ALL;
		si.nMin = 0;
		si.nPage = 0x10;
		height = nHeightMemory[nCPU];
		si.nPos = (pc >> 4);
		if (bAsciiDump) {
			height -= 3;
		}
		si.nMax = ((GetMaxMemArea(bDumpPhysicalAddr) >> 4) + 0x0f) - height;
		SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
	}

	/* ʂA */
	return hWnd;
}

#endif	/* _WIN32 */
